<?php
/*
* Add-on Name: Addresses with map
*/
if ( ! class_exists( 'St_Addresses_Map_Module' ) ) {
	class St_Addresses_Map_Module {
		function __construct() {
			add_shortcode( 'st_addresses_map_module', array( $this, 'addresses_map_module_shortcode' ) );
			add_action( 'init', array( $this, 'addresses_map_module_init' ) );
		}

		function addresses_map_module_shortcode( $atts ) {
			$output   = $el_class = $contact_block_data = $block_heading = $address = $phone = $email = $schedule = $info_window = $lat = $lng = '';
			$block_bg = $marker_icon = $map_colors = $icon_img = $map_min_zoom = '';

			global $st_adamas;
			if ( isset( $st_adamas['google_api_key'] ) && ! empty( $st_adamas['google_api_key'] ) ) {
				$google_api_key = 'key=' . $st_adamas['google_api_key'];
			} else {
				$google_api_key = '';
			}

			wp_enqueue_script( 'st-googlemaps', 'https://maps.googleapis.com/maps/api/js?' . $google_api_key, false, null, true );

			extract( shortcode_atts( array(
				'contact_block_data'    => '',
				'block_heading'         => '',
				'block_bg'              => '',
				'address'               => '',
				'phone'                 => '',
				'email'                 => '',
				'schedule'              => '',
				'lat'                   => '',
				'lng'                   => '',
				'info_window'           => '',
				'map_height'            => '',
				'map_type'              => '',
				'map_scrollwheel'       => '',
				'map_streetviewcontrol' => '',
				'map_maptypecontrol'    => '',
				'map_zoomcontrol'       => '',
				'map_zoomcontrolsize'   => '',
				'map_dragging'          => '',
				'marker_icon'           => '',
				'map_colors'            => '',
				'map_min_zoom'          => '',
				'icon_img'              => '',
				'el_class'              => '',
			), $atts ) );

			$output              = '';
			$block_heading_count = 0;
			$address_count       = 0;
			$phone_count         = 0;
			$email_count         = 0;
			$schedule_count      = 0;

			$contact_block_data = json_decode( urldecode( $contact_block_data ), true );

			$block_id    = uniqid( 'st-addresses-map-' );
			$carousel_id = uniqid( 'st-addresses-map-carousel-' );

			if ( ! empty( $block_bg ) ) {
				$img      = wp_get_attachment_image_src( $block_bg, 'full' );
				$bg_style = 'style="background-image:url(' . esc_url( $img[0] ) . ')"';
			} else {
				$bg_style = '';
			}

			$id       = "map_" . uniqid();
			$wrap_id  = "wrap_" . $id;
			$map_type = strtoupper( $map_type );

			if ( $map_height == '' || empty( $map_height ) ) {
				$map_height = '400';
			}

			$map_height = ( substr( $map_height, - 1 ) != "%" && substr( $map_height, - 2 ) != "px" ? $map_height . "px" : $map_height );

			if ( $marker_icon == 'custom' ) {
				$icon_url = apply_filters( 'ult_get_img_single', $icon_img, 'url' );
			} else {
				$icon_url = '';
			}

			if ( empty( $map_dragging ) ) {
				$map_dragging = 'true';
			}

			if ( empty( $map_colors ) || $map_type != 'ROADMAP' ) {
				$map_style = '';
			}

			if ( empty( $map_min_zoom ) ) {
				$map_min_zoom = '16';
			}

			if ( $map_colors == 'silver' ) {
				$map_style = 'styles: 
				[
					{
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#f5f5f5"
						}
					  ]
					},
					{
					  "elementType": "labels.icon",
					  "stylers": [
						{
						  "visibility": "off"
						}
					  ]
					},
					{
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#616161"
						}
					  ]
					},
					{
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#f5f5f5"
						}
					  ]
					},
					{
					  "featureType": "administrative.land_parcel",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#bdbdbd"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#eeeeee"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#757575"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#e5e5e5"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#9e9e9e"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#ffffff"
						}
					  ]
					},
					{
					  "featureType": "road.arterial",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#757575"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#dadada"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#616161"
						}
					  ]
					},
					{
					  "featureType": "road.local",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#9e9e9e"
						}
					  ]
					},
					{
					  "featureType": "transit.line",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#e5e5e5"
						}
					  ]
					},
					{
					  "featureType": "transit.station",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#eeeeee"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#c9c9c9"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#9e9e9e"
						}
					  ]
					}
				],';
			}

			if ( $map_colors == 'retro' ) {
				$map_style = 'styles:
				[
					{
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#ebe3cd"
						}
					  ]
					},
					{
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#523735"
						}
					  ]
					},
					{
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#f5f1e6"
						}
					  ]
					},
					{
					  "featureType": "administrative",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#c9b2a6"
						}
					  ]
					},
					{
					  "featureType": "administrative.land_parcel",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#dcd2be"
						}
					  ]
					},
					{
					  "featureType": "administrative.land_parcel",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#ae9e90"
						}
					  ]
					},
					{
					  "featureType": "landscape.natural",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#dfd2ae"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#dfd2ae"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#93817c"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "geometry.fill",
					  "stylers": [
						{
						  "color": "#a5b076"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#447530"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#f5f1e6"
						}
					  ]
					},
					{
					  "featureType": "road.arterial",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#fdfcf8"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#f8c967"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#e9bc62"
						}
					  ]
					},
					{
					  "featureType": "road.highway.controlled_access",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#e98d58"
						}
					  ]
					},
					{
					  "featureType": "road.highway.controlled_access",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#db8555"
						}
					  ]
					},
					{
					  "featureType": "road.local",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#806b63"
						}
					  ]
					},
					{
					  "featureType": "transit.line",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#dfd2ae"
						}
					  ]
					},
					{
					  "featureType": "transit.line",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#8f7d77"
						}
					  ]
					},
					{
					  "featureType": "transit.line",
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#ebe3cd"
						}
					  ]
					},
					{
					  "featureType": "transit.station",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#dfd2ae"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "geometry.fill",
					  "stylers": [
						{
						  "color": "#b9d3c2"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#92998d"
						}
					  ]
					}
				],';
			}

			if ( $map_colors == 'dark' ) {
				$map_style = 'styles:
				[
					{
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#212121"
						}
					  ]
					},
					{
					  "elementType": "labels.icon",
					  "stylers": [
						{
						  "visibility": "off"
						}
					  ]
					},
					{
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#757575"
						}
					  ]
					},
					{
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#212121"
						}
					  ]
					},
					{
					  "featureType": "administrative",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#757575"
						}
					  ]
					},
					{
					  "featureType": "administrative.country",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#9e9e9e"
						}
					  ]
					},
					{
					  "featureType": "administrative.land_parcel",
					  "stylers": [
						{
						  "visibility": "off"
						}
					  ]
					},
					{
					  "featureType": "administrative.locality",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#bdbdbd"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#757575"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#181818"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#616161"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#1b1b1b"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "geometry.fill",
					  "stylers": [
						{
						  "color": "#2c2c2c"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#8a8a8a"
						}
					  ]
					},
					{
					  "featureType": "road.arterial",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#373737"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#3c3c3c"
						}
					  ]
					},
					{
					  "featureType": "road.highway.controlled_access",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#4e4e4e"
						}
					  ]
					},
					{
					  "featureType": "road.local",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#616161"
						}
					  ]
					},
					{
					  "featureType": "transit",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#757575"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#000000"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#3d3d3d"
						}
					  ]
					}
				],';
			}

			if ( $map_colors == 'night' ) {
				$map_style = 'styles:
				[
					{
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#242f3e"
						}
					  ]
					},
					{
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#746855"
						}
					  ]
					},
					{
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#242f3e"
						}
					  ]
					},
					{
					  "featureType": "administrative.locality",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#d59563"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#d59563"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#263c3f"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#6b9a76"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#38414e"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#212a37"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#9ca5b3"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#746855"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#1f2835"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#f3d19c"
						}
					  ]
					},
					{
					  "featureType": "transit",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#2f3948"
						}
					  ]
					},
					{
					  "featureType": "transit.station",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#d59563"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#17263c"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#515c6d"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#17263c"
						}
					  ]
					}
				],';
			}

			if ( $map_colors == 'night' ) {
				$map_style = 'styles:
				[
					{
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#1d2c4d"
						}
					  ]
					},
					{
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#8ec3b9"
						}
					  ]
					},
					{
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#1a3646"
						}
					  ]
					},
					{
					  "featureType": "administrative.country",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#4b6878"
						}
					  ]
					},
					{
					  "featureType": "administrative.land_parcel",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#64779e"
						}
					  ]
					},
					{
					  "featureType": "administrative.province",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#4b6878"
						}
					  ]
					},
					{
					  "featureType": "landscape.man_made",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#334e87"
						}
					  ]
					},
					{
					  "featureType": "landscape.natural",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#023e58"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#283d6a"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#6f9ba5"
						}
					  ]
					},
					{
					  "featureType": "poi",
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#1d2c4d"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "geometry.fill",
					  "stylers": [
						{
						  "color": "#023e58"
						}
					  ]
					},
					{
					  "featureType": "poi.park",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#3C7680"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#304a7d"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#98a5be"
						}
					  ]
					},
					{
					  "featureType": "road",
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#1d2c4d"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#2c6675"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "geometry.stroke",
					  "stylers": [
						{
						  "color": "#255763"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#b0d5ce"
						}
					  ]
					},
					{
					  "featureType": "road.highway",
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#023e58"
						}
					  ]
					},
					{
					  "featureType": "transit",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#98a5be"
						}
					  ]
					},
					{
					  "featureType": "transit",
					  "elementType": "labels.text.stroke",
					  "stylers": [
						{
						  "color": "#1d2c4d"
						}
					  ]
					},
					{
					  "featureType": "transit.line",
					  "elementType": "geometry.fill",
					  "stylers": [
						{
						  "color": "#283d6a"
						}
					  ]
					},
					{
					  "featureType": "transit.station",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#3a4762"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "geometry",
					  "stylers": [
						{
						  "color": "#0e1626"
						}
					  ]
					},
					{
					  "featureType": "water",
					  "elementType": "labels.text.fill",
					  "stylers": [
						{
						  "color": "#4e6d70"
						}
					  ]
					}
				],';
			}

			if ( empty( $map_streetviewcontrol ) ) {
				$map_streetviewcontrol = 'false';
			}

			if ( empty( $map_maptypecontrol ) ) {
				$map_maptypecontrol = 'false';
			}

			if ( empty( $map_type ) ) {
				$map_type = 'ROADMAP';
			}

			if ( empty( $map_zoomcontrol ) ) {
				$map_zoomcontrol = 'true';
			}

			if ( empty( $map_zoomcontrolsize ) ) {
				$map_zoomcontrolsize = 'SMALL';
			}

			if ( $map_scrollwheel == 'disable' ) {
				$map_scrollwheel = 'false';
			} else {
				$map_scrollwheel = 'true';
			}

			$output .= '<div class="st-addresses-map ' . esc_attr( $el_class ) . '" id="' . esc_attr( $block_id ) . '">';
			if ( isset( $contact_block_data ) ) {
				$output .= '<div class="st-addresses-map-gmap">';
				$output .= '<div id="' . esc_attr( $wrap_id ) . '" ' . ( $map_height != '' ? 'style="height:' . esc_attr( $map_height ) . ';"' : '' ) . '><div id="' . esc_attr( $id ) . '" ' . ( $map_height != '' ? 'style="height:' . esc_attr( $map_height ) . ';"' : '' ) . '></div></div>';
				$output .= '</div>'; // st-addresses-map-gmap
			}
			$output .= '<div class="st-addresses-map-carousel" ' . $bg_style . '>';
			$output .= '<div class="st-addresses-map-overlay"></div>';
			if ( isset( $contact_block_data ) ) {
				$output .= '<div class="st-addresses-map-carousel-inner" id="' . esc_attr( $carousel_id ) . '" >';
				foreach ( $contact_block_data as $contact_block_datas ) {
					$output .= '<div class="st-addresses-map-item" data-lat="' . esc_attr( $contact_block_datas['lat'] ) . '" data-lng="' . $contact_block_datas['lng'] . '" data-info="' . esc_attr( $contact_block_datas['info_window'] ) . '">';
					$output .= '<div class="st-addresses-map-item-inner">';
					if ( isset( $contact_block_datas['block_heading'] ) ) {
						$output .= '<div class="st-addresses-map-item-title"><h3>' . esc_attr( $contact_block_datas['block_heading'] ) . '</h3></div>';
					}
					if ( isset( $contact_block_datas['address'] ) ) {
						$output .= '<div class="st-addresses-map-item-address"><i class="fa fa-map-marker" aria-hidden="true"></i><address>' . esc_attr( $contact_block_datas['address'] ) . '</address></div>';
					}
					if ( isset( $contact_block_datas['phone'] ) ) {
						$output .= '<div class="st-addresses-map-item-phone"><i class="fa fa-phone" aria-hidden="true"></i><a href="tel:' . preg_replace( '/\s+/', '', esc_attr( $contact_block_datas['phone'] ) ) . '">' . esc_attr( $contact_block_datas['phone'] ) . '</a></div>';
					}
					if ( isset( $contact_block_datas['email'] ) ) {
						$output .= '<div class="st-addresses-map-item-email"><i class="fa fa-envelope" aria-hidden="true"></i><a href="mailto:' . sanitize_email( $contact_block_datas['email'] ) . '">' . sanitize_email( $contact_block_datas['email'] ) . '</a></div>';
					}
					if ( isset( $contact_block_datas['schedule'] ) ) {
						$output .= '<div class="st-addresses-map-item-schedule"><i class="fa fa-clock-o" aria-hidden="true"></i>' . esc_attr( $contact_block_datas['schedule'] ) . '</div>';
					}
					$output .= '</div>'; // st-addresses-map-item-inner
					$output .= '</div>'; // st-addresses-map-item
				}
				$output .= '</div>'; // st-addresses-map-carousel-inner
			}
			$output .= '</div>'; // st-addresses-map-carousel
			$output .= '</div>'; // st-addresses-map

			wp_enqueue_script( 'slick' );

			$rtl = '';
			if ( is_rtl() ) {
				$rtl = 'rtl:true';
			}

			$output .= '<script type="text/javascript">
			jQuery(document).ready(function($){
				"use strict";
				
				var map_' . esc_js( $id ) . ', marker, addresses = [], flag = [], isDraggable = $(document).width() > 641 ? true : ' . esc_js( $map_dragging ) . ';
				google.maps.event.addDomListener(window, "load", initMap_' . esc_js( $id ) . ');
				
				function initMap_' . esc_js( $id ) . '(){
					var mapOptions = {
						scaleControl: true,
						streetViewControl: ' . esc_js( $map_streetviewcontrol ) . ',
						mapTypeControl: ' . esc_js( $map_maptypecontrol ) . ',
						panControl: false,
						zoomControl: ' . esc_js( $map_zoomcontrol ) . ',
						scrollwheel: ' . esc_js( $map_scrollwheel ) . ',
						draggable: isDraggable,
						' . $map_style . '
						zoomControlOptions: {
							style: google.maps.ZoomControlStyle.' . esc_js( $map_zoomcontrolsize ) . '
						},
						
						mapTypeId: google.maps.MapTypeId.' . esc_js( $map_type ) . ',
					};
					
					var mapCanvas = document.getElementById("' . esc_js( $id ) . '");
					map_' . esc_js( $id ) . ' = new google.maps.Map(mapCanvas, mapOptions);
					
					$("#' . esc_js( $carousel_id ) . '").on("init swipe click", function(event, slick){
						st_adamas_adressMarkers();
					});
					
					$("#' . esc_js( $carousel_id ) . '").slick({rows:0,slidesToShow:3,slidesToScroll:3,arrows:false,dots:true,infinite:false,responsive:[{breakpoint:767,settings:{slidesToShow:1,slidesToScroll:1,infinite:false}},{breakpoint:1199,settings:{slidesToShow:2,slidesToScroll:2,infinite:false}}],' . esc_js( $rtl ) . '});
					var $item = $("#' . esc_js( $carousel_id ) . '").find(".st-addresses-map-item-inner");
					$item.matchHeight(true);
				}
				
				function st_adamas_adressMarkers(title){
					var carousel = $("#' . esc_js( $carousel_id ) . '");
					var bounds = new google.maps.LatLngBounds();
					addresses = [];
					
					carousel.find(".st-addresses-map-item.slick-active").each(function(i){
						addresses.push([parseFloat($(this).data("lat")), parseFloat($(this).data("lng")), $(this).data("info")]);
					});
					
					for(i = 0; i < flag.length; i++){
						flag[i].setMap(null);
					}

					for(var i = 0; i < addresses.length; i++){
						var addressesArr = addresses[i];
						marker = new google.maps.Marker({
							position: {lat: addressesArr[0], lng: addressesArr[1]},
							map: map_' . esc_js( $id ) . ',
							icon: "' . esc_js( $icon_url ) . '",
							title: addressesArr[2]
						});
						bounds.extend(new google.maps.LatLng(addressesArr[0], addressesArr[1]));
						flag.push(marker);
						InfoWindowInit(marker, addressesArr[2], addressesArr[0]);
					}
					map_' . esc_js( $id ) . '.fitBounds(bounds);
					var listener = google.maps.event.addListener(map_' . esc_js( $id ) . ', "bounds_changed", function(){ 
						if (this.getZoom() > ' . esc_js( $map_min_zoom ) . ') this.setZoom(' . esc_js( $map_min_zoom ) . ');
						google.maps.event.removeListener(listener);
					});
				}
				
				function InfoWindowInit(marker, title, lat){
					if(title.length > 0){
						var info_window = new google.maps.InfoWindow({
							content: "<h3>" + title + "</h3>",
						});
	
						google.maps.event.addListener(marker, "mouseover", function(){
							info_window.open(map_' . esc_js( $id ) . ', marker);
							$("[data-lat="/"+ lat +"/"]").addClass("hover");
						});
	
						google.maps.event.addListener(marker, "mouseout", function(){
							info_window.close(map_' . esc_js( $id ) . ', marker);
							$("[data-lat="/"+ lat +"/"]").removeClass("hover");
						});
	
						$(".st-addresses-map-item").on("mouseenter", function(){
							if(parseFloat(marker.getPosition().lat()) === parseFloat($(this).data("lat"))){
								info_window.open(map_' . esc_js( $id ) . ', marker);
							}
						});
	
						$(".st-addresses-map-item").on("mouseleave", function(){
							if(parseFloat(marker.getPosition().lat()) === parseFloat($(this).data("lat"))){
								info_window.close(map_' . esc_js( $id ) . ', marker);
							}
						});
					}
				}
			});
			</script>';

			return $output;
		}

		function addresses_map_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Addresses with Google Maps', 'adamas-vc-shortcodes' ),
					'base'        => 'st_addresses_map_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/addresses_with_google_maps.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Background image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_bg',
							'description' => '',
						),
						array(
							'type'        => 'param_group',
							'heading'     => __( 'Contack block data', 'adamas-vc-shortcodes' ),
							'param_name'  => 'contact_block_data',
							'description' => '',
							'value'       => urlencode( json_encode( array(
								array(
									'block_heading' => '',
									'address'       => '',
									'phone'         => '',
									'email'         => '',
									'schedule'      => '',
									'info_window'   => '',
									'lat'           => '',
									'lng'           => '',
								)
							) ) ),
							'params'      => array(
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Block heading', 'adamas-vc-shortcodes' ),
									'param_name'  => 'block_heading',
									'description' => '',
									'admin_label' => true,
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Address', 'adamas-vc-shortcodes' ),
									'param_name'  => 'address',
									'description' => '',
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Phone number', 'adamas-vc-shortcodes' ),
									'param_name'  => 'phone',
									'description' => '',
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'E-mail', 'adamas-vc-shortcodes' ),
									'param_name'  => 'email',
									'description' => '',
								),
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Schedule', 'adamas-vc-shortcodes' ),
									'param_name'  => 'schedule',
									'description' => '',
								),
								array(
									'type'        => 'textfield',
									'class'       => '',
									'heading'     => __( 'Marker title', 'adamas-vc-shortcodes' ),
									'param_name'  => 'info_window',
									'description' => __( 'Enter text for info window above map marker.', 'adamas-vc-shortcodes' ),
								),
								array(
									"type"        => "textfield",
									"class"       => "",
									"heading"     => __( "Latitude", "adamas-vc-shortcodes" ),
									"param_name"  => "lat",
									"value"       => "",
									"description" => '<a href="http://universimmedia.pagesperso-orange.fr/geo/loc.htm" target="_blank">' . __( 'Here is a tool', 'adamas-vc-shortcodes' ) . '</a> ' . __( 'where you can find Latitude & Longitude of your location', 'adamas-vc-shortcodes' ),
								),
								array(
									"type"        => "textfield",
									"class"       => "",
									"heading"     => __( "Longitude", "adamas-vc-shortcodes" ),
									"param_name"  => "lng",
									"value"       => "",
									"description" => '<a href="http://universimmedia.pagesperso-orange.fr/geo/loc.htm" target="_blank">' . __( 'Here is a tool', 'adamas-vc-shortcodes' ) . '</a> ' . __( 'where you can find Latitude & Longitude of your location', "adamas-vc-shortcodes" ),
								),
							),
						),
						array(
							'type'       => 'textfield',
							'heading'    => __( 'Height (in px)', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_height',
							'value'      => '400px',
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'heading'    => __( 'Map type', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_type',
							'value'      => array(
								__( 'Roadmap', 'adamas-vc-shortcodes' )   => 'ROADMAP',
								__( 'Satellite', 'adamas-vc-shortcodes' ) => 'SATELLITE',
								__( 'Hybrid', 'adamas-vc-shortcodes' )    => 'HYBRID',
								__( 'Terrain', 'adamas-vc-shortcodes' )   => 'TERRAIN'
							),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'heading'    => __( 'Map Color Scheme', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_colors',
							'value'      => array(
								__( 'Standard', 'adamas-vc-shortcodes' )  => '',
								__( 'Silver', 'adamas-vc-shortcodes' )    => 'silver',
								__( 'Retro', 'adamas-vc-shortcodes' )     => 'retro',
								__( 'Dark', 'adamas-vc-shortcodes' )      => 'dark',
								__( 'Night', 'adamas-vc-shortcodes' )     => 'night',
								__( 'Aubergine', 'adamas-vc-shortcodes' ) => 'aubergine',
							),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
							'dependency' => Array( 'element' => 'map_type', 'value' => array( 'ROADMAP' ) ),
						),
						array(
							'type'       => 'checkbox',
							'heading'    => '',
							'param_name' => 'map_scrollwheel',
							'value'      => array(
								__( 'Disable map zoom on mouse wheel scroll', 'adamas-vc-shortcodes' ) => 'disable',
							),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'dropdown',
							'heading'     => __( 'Map Min Zoom', 'adamas-vc-shortcodes' ),
							'param_name'  => 'map_min_zoom',
							'value'       => array(
								__( '16 - Default', 'adamas-vc-shortcodes' ) => 16,
								1,
								2,
								3,
								4,
								5,
								6,
								7,
								8,
								9,
								10,
								11,
								12,
								13,
								14,
								15,
								17,
								18,
								19,
								20
							),
							'description' => __( 'Minimum zoom for map.', 'adamas-vc-shortcodes' ),
							'group'       => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'class'      => '',
							'heading'    => __( 'Street view control', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_streetviewcontrol',
							'value'      => array( __( 'Disable', 'adamas-vc-shortcodes' ) => 'false', __( 'Enable', 'adamas-vc-shortcodes' ) => 'true' ),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'class'      => '',
							'heading'    => __( 'Map type control', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_maptypecontrol',
							'value'      => array( __( 'Disable', 'adamas-vc-shortcodes' ) => 'false', __( 'Enable', 'adamas-vc-shortcodes' ) => 'true' ),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'class'      => '',
							'heading'    => __( 'Zoom control', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_zoomcontrol',
							'value'      => array( __( 'Disable', 'adamas-vc-shortcodes' ) => 'false', __( 'Enable', 'adamas-vc-shortcodes' ) => 'true' ),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'class'      => '',
							'heading'    => __( 'Zoom control size', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_zoomcontrolsize',
							'value'      => array( __( 'Small', 'adamas-vc-shortcodes' ) => 'SMALL', __( 'Large', 'adamas-vc-shortcodes' ) => 'LARGE' ),
							'dependency' => Array( 'element' => 'map_zoomcontrol', 'value' => array( 'true' ) ),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'сlass'      => '',
							'heading'    => __( 'Disable dragging on Mobile', 'adamas-vc-shortcodes' ),
							'param_name' => 'map_dragging',
							'value'      => array( __( 'Enable', 'adamas-vc-shortcodes' ) => 'true', __( 'Disable', 'adamas-vc-shortcodes' ) => 'false' ),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'class'      => '',
							'heading'    => __( 'Marker/Point icon', 'adamas-vc-shortcodes' ),
							'param_name' => 'marker_icon',
							'value'      => array( __( 'Use Google Default', 'adamas-vc-shortcodes' ) => 'default', __( 'Upload Custom', 'adamas-vc-shortcodes' ) => 'custom' ),
							'group'      => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'ult_img_single',
							'class'       => '',
							'heading'     => __( 'Upload Image Icon:', 'adamas-vc-shortcodes' ),
							'param_name'  => 'icon_img',
							'value'       => '',
							'description' => __( 'Upload the custom marker image.', 'adamas-vc-shortcodes' ),
							'dependency'  => Array( 'element' => 'marker_icon', 'value' => array( 'custom' ) ),
							'group'       => __( 'Google Map', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Extra class name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'el_class',
							'description' => __( 'If you wish to style particular content element differently, then use this field to add a class name and then refer to it in your css file.', 'adamas-vc-shortcodes' )
						),
					)
				) );
			}
		}
	}

	$st_addresses_map_module = new St_Addresses_Map_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_addresses_map_module extends WPBakeryShortCode {
		}
	}
}