<?php
/*
* Add-on Name: Award Block Module
*/
if ( ! class_exists( 'St_Award_Block_Module' ) ) {
	class St_Award_Block_Module {
		function __construct() {
			add_shortcode( 'st_award_block_module', array( $this, 'award_block_module_shortcode' ) );
			add_action( 'init', array( $this, 'award_block_module_init' ) );
		}

		function award_block_module_shortcode( $atts, $content ) {
			$output = $award_block_logo = $award_block_title = $award_block_subtitle = $award_block_title_font = $award_block_title_font_style = $award_block_title_color = $award_block_title_font_size = $award_block_title_line_height = $award_block_title_letter_spacing = $award_block_subtitle_font = $award_block_subtitle_font_style = $award_block_subtitle_color = $award_block_subtitle_font_size = $award_block_subtitle_line_height = $award_block_subtitle_letter_spacing = $award_block_desc_font = $award_block_desc_font_style = $award_block_desc_color = $award_block_desc_font_size = $award_block_desc_line_height = $award_block_desc_letter_spacing = $award_disable_border = $module_animation = $animation = $animated = $el_class = '';

			extract( shortcode_atts( array(
				'award_block_logo'                    => '',
				'award_block_title'                   => '',
				'award_block_subtitle'                => '',
				'award_block_title_font'              => '',
				'award_block_title_font_style'        => '',
				'award_block_title_color'             => '',
				'award_block_title_font_size'         => '',
				'award_block_title_line_height'       => '',
				'award_block_title_letter_spacing'    => '',
				'award_block_subtitle_font'           => '',
				'award_block_subtitle_font_style'     => '',
				'award_block_subtitle_color'          => '',
				'award_block_subtitle_font_size'      => '',
				'award_block_subtitle_line_height'    => '',
				'award_block_subtitle_letter_spacing' => '',
				'award_block_desc_font'               => '',
				'award_block_desc_font_style'         => '',
				'award_block_desc_color'              => '',
				'award_block_desc_font_size'          => '',
				'award_block_desc_line_height'        => '',
				'award_block_desc_letter_spacing'     => '',
				'award_disable_border'                => '',
				'module_animation'                    => '',
				'el_class'                            => '',
			), $atts ) );


			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$id = uniqid( 'st-award-block-' );

			if ( $award_disable_border ) {
				$el_class .= ' disable-border';
			}

			$img     = wp_get_attachment_image_src( $atts['award_block_logo'], 'full' );
			$img_alt = strip_tags( get_post_meta( $atts['award_block_logo'], '_wp_attachment_image_alt', true ) );
			if ( $img_alt ) {
				$alt = $img_alt;
			} else {
				$alt = $award_block_title;
			}
			$img_link = $img[0];

			// Award block title
			$award_block_title_style = 'style="';

			if ( $award_block_title_font !== '' ) {
				$award_block_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $award_block_title_font ) : '';
				$award_block_title_style       .= ! empty( $award_block_title_font_family ) ? 'font-family:\'' . $award_block_title_font_family . '\';' : '';
			}

			if ( is_numeric( $award_block_title_font_size ) ) {
				$award_block_title_font_size = 'desktop: ' . $award_block_title_font_size . 'px;';
			}
			if ( is_numeric( $award_block_title_line_height ) ) {
				$award_block_title_line_height = 'desktop: ' . $award_block_title_line_height . 'px;';
			}

			$award_block_title_args = array(
				'target'      => '#' . $id . ' .st-award-block-title',
				'media_sizes' => array(
					'font-size'   => $award_block_title_font_size,
					'line-height' => $award_block_title_line_height,
				),
			);

			$award_block_title_responsive = get_ultimate_vc_responsive_media_css( $award_block_title_args );
			$award_block_title_style      .= $award_block_title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $award_block_title_letter_spacing ) . 'px;' : '';
			$award_block_title_style      .= '"';

			// Award block subtitle
			$award_block_subtitle_style = 'style="';

			if ( $award_block_subtitle_font !== '' ) {
				$award_block_subtitle_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $award_block_subtitle_font ) : '';
				$award_block_subtitle_style       .= 'font-family:\'' . $award_block_subtitle_font_family . '\';';
			}

			if ( is_numeric( $award_block_subtitle_font_size ) ) {
				$award_block_subtitle_font_size = 'desktop: ' . $award_block_subtitle_font_size . 'px;';
			}
			if ( is_numeric( $award_block_subtitle_line_height ) ) {
				$award_block_subtitle_line_height = 'desktop: ' . $award_block_subtitle_line_height . 'px;';
			}

			$award_block_subtitle_args = array(
				'target'      => '#' . $id . ' .st-award-block-subtitle',
				'media_sizes' => array(
					'font-size'   => $award_block_subtitle_font_size,
					'line-height' => $award_block_subtitle_line_height,
				),
			);

			$award_block_subtitle_responsive = get_ultimate_vc_responsive_media_css( $award_block_subtitle_args );
			$award_block_subtitle_style      .= $award_block_subtitle_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $award_block_subtitle_letter_spacing ) . 'px;' : '';
			$award_block_subtitle_style      .= '"';

			// Award block description
			$award_block_desc_style = 'style="';

			if ( $award_block_desc_font !== '' ) {
				$award_block_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $award_block_desc_font ) : '';
				$award_block_desc_style       .= 'font-family:\'' . $award_block_desc_font_family . '\';';
			}

			if ( is_numeric( $award_block_desc_font_size ) ) {
				$award_block_desc_font_size = 'desktop: ' . $award_block_desc_font_size . 'px;';
			}
			if ( is_numeric( $award_block_desc_line_height ) ) {
				$award_block_desc_line_height = 'desktop: ' . $award_block_desc_line_height . 'px;';
			}

			$award_block_desc_args = array(
				'target'      => '#' . $id . ' .st-award-block-desc',
				'media_sizes' => array(
					'font-size'   => $award_block_desc_font_size,
					'line-height' => $award_block_desc_line_height,
				),
			);

			$award_block_desc_responsive = get_ultimate_vc_responsive_media_css( $award_block_desc_args );
			$award_block_desc_style      .= $award_block_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $award_block_desc_letter_spacing ) . 'px;' : '';
			$award_block_desc_style      .= '"';

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-awards-block ' . esc_attr( $el_class ) . '" id="' . esc_attr( $id ) . '">';
			$output .= '<div class="st-awards-block-logo"><img src="' . esc_url( $img_link ) . '" alt="' . esc_attr( $alt ) . '" /></div>';
			$output .= '<div class="st-awards-block-inner ' . $animated . '" ' . $animation . '>';
			$output .= '<div class="st-awards-title-wrapper"><i class="st-h-before"><i></i></i>';
			$output .= '<div class="st-awards-block-title ult-responsive" ' . $award_block_title_style . ' ' . $award_block_title_responsive . '>' . esc_attr( $award_block_title ) . '</div>';
			$output .= '<div class="st-awards-block-subtitle ult-responsive" ' . $award_block_subtitle_style . ' ' . $award_block_subtitle_responsive . '>' . esc_attr( $award_block_subtitle ) . '</div>';
			$output .= '</div>'; // st-awards-title-wrapper
			$output .= '<div class="st-awards-block-desc ult-responsive" ' . $award_block_desc_style . ' ' . $award_block_desc_responsive . '>' . do_shortcode( $content ) . '</div>';
			$output .= '</div>'; // st-awards-block-inner
			$output .= '</div>'; // st-awards-block

			return $output;
		}

		function award_block_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Award Block', 'adamas-vc-shortcodes' ),
					'base'        => 'st_award_block_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/award_block.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays award info', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Logo', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_logo',
							'description' => '',
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_title',
							'description' => '',
							'admin_label' => true
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Subtitle', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_subtitle',
							'description' => '',
						),
						array(
							'type'        => 'textarea_html',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
						),
						array(
							'type'        => 'checkbox',
							'heading'     => __( 'Disable bottom border', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_disable_border',
							'value'       => array( __( 'Yes', 'adamas-vc-shortcodes' ) => 'yes' ),
							'description' => ''
						),

						// Award title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_title_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_title_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Award subtitle typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Subtitle font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_subtitle_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Subtitle font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_subtitle_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Subtitle font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_subtitle_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Subtitle font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_subtitle_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Subtitle line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_subtitle_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Subtitle letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_subtitle_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Award description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Description font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_desc_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Description font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_desc_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'award_block_desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_award_block_module = new St_Award_Block_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_award_block_module extends WPBakeryShortCode {
		}
	}
}