<?php
/*
* Add-on Name: Info Block Module
*/
if ( ! class_exists( 'St_Info_Block_Module' ) ) {
	class St_Info_Block_Module {
		function __construct() {
			add_shortcode( 'st_info_block_module', array( $this, 'info_block_module_shortcode' ) );
			add_action( 'init', array( $this, 'info_block_module_init' ) );
		}

		function info_block_module_shortcode( $atts, $content ) {
			$output            = $block_id = $block_layout = $block_title = $block_title_align = $block_number = $block_image = $block_bg_color = $module_animation = '';
			$block_title_font  = $block_title_font_style = $block_title_color = $block_title_font_size = $block_title_line_height = $block_title_letter_spacing = '';
			$block_desc_font   = $block_desc_font_size = $block_desc_line_height = $block_desc_letter_spacing = '';
			$block_number_font = $block_number_font_style = $block_number_color = $block_number_font_size = $block_number_line_height = $block_number_letter_spacing = '';
			$animated          = $animation = '';

			extract( shortcode_atts( array(
				'block_id'                    => '',
				'block_layout'                => '',
				'block_title'                 => '',
				'block_title_align'           => '',
				'block_number'                => '',
				'block_image'                 => '',
				'block_bg_color'              => '',
				'block_title_font'            => '',
				'block_title_font_style'      => '',
				'block_title_color'           => '',
				'block_title_font_size'       => '',
				'block_title_line_height'     => '',
				'block_title_letter_spacing'  => '',
				'block_desc_font'             => '',
				'block_desc_font_size'        => '',
				'block_desc_line_height'      => '',
				'block_desc_letter_spacing'   => '',
				'block_number_font'           => '',
				'block_number_font_style'     => '',
				'block_number_color'          => '',
				'block_number_font_size'      => '',
				'block_number_line_height'    => '',
				'block_number_letter_spacing' => '',
				'block_link'                  => '',
				'module_animation'            => '',
				'el_class'                    => '',
			), $atts ) );


			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			if ( $block_id != '' ) {
				$info_block_id = 'id="' . esc_attr( $block_id ) . '"';
			}

			if ( empty( $block_layout ) ) {
				$block_layout = 'info-block-image-text';
			}

			if ( empty( $block_title_align ) ) {
				$block_title_align = 'left';
			}

			if ( $block_bg_color ) {
				$bg = 'style="background-color:' . esc_attr( $block_bg_color ) . '"';
			}

			$id = uniqid( 'st-info-block-' );

			// Title
			$block_title_style = 'style="';

			if ( $block_title_font !== '' ) {
				$block_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $block_title_font ) : '';
				$block_title_style       .= ! empty( $block_title_font_family ) ? 'font-family:\'' . $block_title_font_family . '\';' : '';
			}
			if ( $block_title_font_style !== '' ) {
				$block_title_style .= esc_attr( $block_title_font_style );
			}

			if ( is_numeric( $block_title_font_size ) ) {
				$block_title_font_size = 'desktop: ' . $block_title_font_size . 'px;';
			}
			if ( is_numeric( $block_title_line_height ) ) {
				$block_title_line_height = 'desktop: ' . $block_title_line_height . 'px;';
			}

			$block_title_args = array(
				'target'      => '#' . $id . ' .st-info-block-title',
				'media_sizes' => array(
					'font-size'   => $block_title_font_size,
					'line-height' => $block_title_line_height,
				),
			);

			$block_title_responsive = get_ultimate_vc_responsive_media_css( $block_title_args );
			$block_title_style      .= $block_title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $block_title_letter_spacing ) . 'px;' : '';
			$block_title_style      .= $block_title_color !== '' ? 'color:' . esc_attr( $block_title_color ) . ';' : '';
			$block_title_style      .= '"';

			// Description
			$block_desc_style = 'style="';

			if ( $block_desc_font !== '' ) {
				$block_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $block_desc_font ) : '';
				$block_desc_style       .= ! empty( $block_desc_font_family ) ? 'font-family:\'' . $block_desc_font_family . '\';' : '';
			}

			if ( is_numeric( $block_desc_font_size ) ) {
				$block_desc_font_size = 'desktop: ' . $block_desc_font_size . 'px;';
			}
			if ( is_numeric( $block_desc_line_height ) ) {
				$block_desc_line_height = 'desktop: ' . $block_desc_line_height . 'px;';
			}

			$block_desc_args = array(
				'target'      => '#' . $id . ' .st-info-block-desc',
				'media_sizes' => array(
					'font-size'   => $block_desc_font_size,
					'line-height' => $block_desc_line_height,
				),
			);

			$block_desc_responsive = get_ultimate_vc_responsive_media_css( $block_desc_args );
			$block_desc_style      .= $block_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $block_desc_letter_spacing ) . 'px;' : '';
			$block_desc_style      .= '"';

			// Number
			$block_number_style = 'style="';

			if ( $block_number_font !== '' ) {
				$block_number_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $block_number_font ) : '';
				$block_number_style       .= ! empty( $block_number_font_family ) ? 'font-family:\'' . $block_number_font_family . '\';' : '';
			}
			if ( $block_number_font_style !== '' ) {
				$block_number_style .= $block_number_font_style;
			}

			if ( is_numeric( $block_number_font_size ) ) {
				$block_number_font_size = 'desktop: ' . $block_number_font_size . 'px;';
			}
			if ( is_numeric( $block_number_line_height ) ) {
				$block_number_line_height = 'desktop: ' . $block_number_line_height . 'px;';
			}

			$block_number_args = array(
				'target'      => '#' . $id . ' .st-info-block-number',
				'media_sizes' => array(
					'font-size'   => $block_number_font_size,
					'line-height' => $block_number_line_height,
				),
			);

			$block_number_responsive = get_ultimate_vc_responsive_media_css( $block_number_args );
			$block_number_style      .= $block_number_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $block_number_letter_spacing ) . 'px;' : '';
			$block_number_style      .= $block_number_color !== '' ? 'color:' . esc_attr( $block_number_color ) . ';' : '';
			$block_number_style      .= $block_bg_color !== '' ? 'background-color:' . esc_attr( $block_bg_color ) . ';' : '';
			$block_number_style      .= '"';

			if ( ! empty( $block_link ) ) {
				$block_link = vc_build_link( $block_link );
				$link       = '<a class="st-info-block-link" href="' . esc_url( $block_link['url'] ) . '" ' . ( $block_link['target'] ? ' target="' . esc_attr( trim( $block_link['target'] ) ) . '"' : '' ) . ' title="' . esc_attr( $block_link['title'] ) . '" ' . ( $block_link['rel'] ? ' rel="' . esc_attr( $block_link['rel'] ) . '"' : '' ) . '>' . esc_attr( $block_link['title'] ) . '</a>';
			} else {
				$link = '';
			}

			$content = wpb_js_remove_wpautop( $content, true );

			if ( isset( $block_image ) ) {
				$img      = wp_get_attachment_image_src( $block_image, 'full' );
				$img_link = $img[0];
				$bg_img   = 'style="background-image:url(' . esc_url( $img_link ) . ')"';
			}

			if ( $block_number == '' ) {
				$el_class .= ' no-number';
			}

			$output .= '<div class="st-info-block ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . ' ' . esc_attr( $block_layout ) . '" ' . $animation . ' ' . $info_block_id . '>';
			if ( $block_layout == 'info-block-image-text' ) {
				$output .= '<div class="st-info-block-inner" id="' . esc_attr( $id ) . '">';
				$output .= '<div class="st-info-block-image" ' . $bg_img . '></div>';
				$output .= '<div class="st-info-block-info" ' . $bg . '>';
				$output .= '<div class="st-info-block-title ult-responsive ' . esc_attr( $block_title_align ) . '" ' . $block_title_style . ' ' . $block_title_responsive . '><h3>' . esc_attr( $block_title ) . '</h3></div>';
				$output .= '<div class="st-info-block-desc ult-responsive" ' . $block_desc_style . ' ' . $block_desc_responsive . '>' . do_shortcode( $content ) . '</div>';
				$output .= $link;
				$output .= '</div>'; // st-info-block-info
				$output .= '</div>'; // st-info-block-inner
				if ( $block_number !== '' ) {
					$output .= '<div class="st-info-block-number ult-responsive" ' . $block_number_style . ' ' . $block_number_responsive . '>' . esc_attr( $block_number ) . '</div>';
				}
			} else {
				if ( $block_number !== '' ) {
					$output .= '<div class="st-info-block-number ult-responsive" ' . $block_number_style . ' ' . $block_number_responsive . '>' . esc_attr( $block_number ) . '</div>';
				}
				$output .= '<div class="st-info-block-inner" id="' . $id . '">';
				$output .= '<div class="st-info-block-info" ' . $bg . '>';
				$output .= '<div class="st-info-block-title ult-responsive ' . esc_attr( $block_title_align ) . '" ' . $block_title_style . ' ' . $block_title_responsive . '><h3>' . esc_attr( $block_title ) . '</h3></div>';
				$output .= '<div class="st-info-block-desc ult-responsive" ' . $block_desc_style . ' ' . $block_desc_responsive . '>' . do_shortcode( $content ) . '</div>';
				$output .= $link;
				$output .= '</div>'; // st-info-block-info
				$output .= '<div class="st-info-block-image" ' . $bg_img . '></div>';
				$output .= '</div>'; // st-info-block-inner
			}

			$output .= '</div>'; // st-info-block

			return $output;
		}

		function info_block_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Info Block', 'adamas-vc-shortcodes' ),
					'base'        => 'st_info_block_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/info_block.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays info block', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Block ID', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_id',
							'description' => __( 'Please, set unique ID for this module due to W3C specification.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'       => 'dropdown',
							'heading'    => __( 'Layout', 'adamas-vc-shortcodes' ),
							'param_name' => 'block_layout',
							'value'      => array(
								__( 'Text right - Image left', 'adamas-vc-shortcodes' ) => 'info-block-image-text',
								__( 'Image right - Text left', 'adamas-vc-shortcodes' ) => 'info-block-text-image',
							),
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title',
							'description' => '',
							'admin_label' => true,
						),
						array(
							'type'        => 'dropdown',
							'heading'     => __( 'Title alignment', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title_align',
							'value'       => array(
								__( 'Left', 'adamas-vc-shortcodes' )    => 'left',
								__( 'Center', 'adamas-vc-shortcodes' )  => 'center',
								__( 'Right', 'adamas-vc-shortcodes' )   => 'right',
								__( 'Justify', 'adamas-vc-shortcodes' ) => 'justify',
							),
							'description' => __( 'Please, select title alignment.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Number', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_number',
							'description' => '',
						),
						array(
							'type'        => 'attach_image',
							'heading'     => __( 'Image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_image',
							'description' => '',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Background color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_bg_color',
							'description' => __( 'Please, select color for background.', 'adamas-vc-shortcodes' ),
						),

						array(
							'type'        => 'textarea_html',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
						),

						array(
							'type'        => 'vc_link',
							'heading'     => __( 'Link', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_link',
							'description' => __( 'Add a custom link or select existing page. You can remove existing link as well.', 'adamas-vc-shortcodes' ),
						),

						// Title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Number typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Number font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_number_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Number font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_number_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Number font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_number_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Number font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_number_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Number line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_number_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Number letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'block_number_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_info_block_module = new St_Info_Block_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_info_block_module extends WPBakeryShortCode {
		}
	}
}