<?php

$el_class = $contact_block_table = $contact_block_img = $contact_block_cf_id = $map_lat = $map_lng = $module_animation = $animation = $animated = '';
$output   = '';

global $st_adamas;
if ( isset( $st_adamas['google_api_key'] ) ) {
	$google_api_key = 'key=' . $st_adamas['google_api_key'];
} else {
	$google_api_key = '';
}

wp_enqueue_script( 'st-googlemaps', 'https://maps.googleapis.com/maps/api/js?' . $google_api_key, false, null, true );

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( shortcode_atts( array(
	'module_animation'         => '',
	'contact_block_title'      => '',
	'contact_details_title'    => '',
	'contact_details_address'  => '',
	'contact_details_phone'    => '',
	'contact_details_email'    => '',
	'contact_details_schedule' => '',
	'contact_block_table'      => '',
	'table_first'              => '',
	'table_second'             => '',
	'table_third'              => '',
	'table_fourth'             => '',
	'table_fifth'              => '',
	'department'               => '',
	'phone'                    => '',
	'mail'                     => '',
	'name'                     => '',
	'skype'                    => '',
	'social_facebook'          => '',
	'social_twitter'           => '',
	'social_googleplus'        => '',
	'social_pinterest'         => '',
	'social_linkedin'          => '',
	'social_instagram'         => '',
	'social_vk'                => '',
	'contact_block_img'        => '',
	'contact_form_title'       => '',
	'contact_block_cf_id'      => '',
	'map_title'                => '',
	'map_width'                => '',
	'map_height'               => '',
	'map_type'                 => '',
	'map_lat'                  => '',
	'map_lng'                  => '',
	'map_zoom'                 => '',
	'map_scrollwheel'          => '',
	'map_streetviewcontrol'    => '',
	'map_maptypecontrol'       => '',
	'map_zoomcontrol'          => '',
	'map_zoomcontrolsize'      => '',
	'map_dragging'             => '',
	'marker_icon'              => '',
	'icon_img'                 => '',
	'el_class'                 => '',
), $atts ) );

$el_class = $this->getExtraClass( $el_class );

$css_classes = array(
	$el_class,
);

$block_id = uniqid( 'st-contact-block-' );

$id       = "map_" . uniqid();
$wrap_id  = "wrap_" . $id;
$map_type = strtoupper( $map_type );

$map_width  = ( substr( $map_width, - 1 ) != "%" && substr( $map_width, - 2 ) != "px" ? $map_width . "px" : $map_width );
$map_height = ( substr( $map_height, - 1 ) != "%" && substr( $map_height, - 2 ) != "px" ? $map_height . "px" : $map_height );

$contact_block_table = json_decode( urldecode( $contact_block_table ), true );

$img      = wp_get_attachment_image_src( $atts['contact_block_img'], 'full' );
$img_link = $img[0];
$bg_style = ' style="background-image:url(' . esc_url( $img_link ) . ')"';

if ( $module_animation ) {
	$animated  .= ' st-animation';
	$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
}

if ( $marker_icon == 'custom' ) {
	$icon_url = apply_filters( 'ult_get_img_single', $icon_img, 'url' );
} else {
	$icon_url = '';
}

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, implode( ' ', array_filter( $css_classes ) ), $this->settings['base'], $atts );

$output .= '<div class="st-contact-block ' . esc_attr( $css_class ) . '" id="' . esc_attr( $block_id ) . '">';
$output .= '<div class="st-contact-block-info">';
$output .= '<div class="st-contact-block-image"' . $bg_style . '></div>';
$output .= '<div class="st-contact-block-details">';
$output .= '<div class="st-contact-block-details-inner">';
if ( ! empty( $contact_details_title ) ) {
	$output .= '<h3 class="st-contact-block-details-title">' . esc_attr( $contact_details_title ) . '</h3>';
}
$output .= '<div class="st-contact-block-details-info">';
if ( ! empty( $contact_details_address ) ) {
	$output .= '<div class="st-contact-block-address"><i class="fa fa-map-marker" aria-hidden="true"></i>' . esc_attr( $contact_details_address ) . '</div>';
}
if ( ! empty( $contact_details_phone ) ) {
	$output .= '<div class="st-contact-block-phone"><i class="fa fa-phone" aria-hidden="true"></i>' . esc_attr( $contact_details_phone ) . '</div>';
}
if ( ! empty( $contact_details_email ) ) {
	$output .= '<div class="st-contact-block-email"><i class="fa fa-envelope" aria-hidden="true"></i>' . esc_attr( $contact_details_email ) . '</div>';
}
if ( ! empty( $contact_details_schedule ) ) {
	$output .= '<div class="st-contact-block-schedule"><i class="fa fa-clock-o" aria-hidden="true"></i>' . esc_attr( $contact_details_schedule ) . '</div>';
}
$output .= '</div>';
$output .= '<div class="st-contact-block-socials">';

if ( $social_facebook !== '' ) {
	$facebook_href = vc_build_link( $social_facebook );
	if ( $facebook_href !== '' ) {
		$facebook_target = ( $facebook_href['target'] !== '' ) ? "target='" . esc_attr( trim( $facebook_href['target'] ) ) . "'" : '';
		$facebook_title  = ( $facebook_href['title'] !== '' ) ? "title='" . esc_attr( trim( $facebook_href['title'] ) ) . "'" : '';
		if ( ! empty( $facebook_href['rel'] ) ) {
			$facebook_rel = ' rel="' . esc_attr( $facebook_href['rel'] ) . '"';
		} else {
			$facebook_rel = '';
		}
		if ( ! empty( $facebook_href['url'] ) ) {
			$output .= '<div class="st-contact-block-socials-item"><a href="' . esc_url( $facebook_href['url'] ) . '" ' . $facebook_title . ' ' . $facebook_target . ' ' . $facebook_rel . '><i class="fa fa-facebook" aria-hidden="true"></i></a></div>';
		}
	}
}

if ( $social_twitter !== '' ) {
	$twitter_href = vc_build_link( $social_twitter );
	if ( $twitter_href !== '' ) {
		$twitter_target = ( $twitter_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $twitter_href['target'] ) ) . '"' : '';
		$twitter_title  = ( $twitter_href['title'] !== '' ) ? 'title="' . esc_attr( $twitter_href['title'] ) . '"' : '';
		if ( ! empty( $twitter_href['rel'] ) ) {
			$twitter_rel = ' rel="' . esc_attr( $twitter_href['rel'] ) . '"';
		} else {
			$twitter_rel = '';
		}
		if ( ! empty( $twitter_href['url'] ) ) {
			$output .= '<div class="st-contact-block-socials-item"><a href="' . esc_url( $twitter_href['url'] ) . '" ' . $twitter_title . ' ' . $twitter_target . ' ' . $twitter_rel . '><i class="fa fa-twitter" aria-hidden="true"></i></a></div>';
		}
	}
}

if ( $social_googleplus !== '' ) {
	$googleplus_href = vc_build_link( $social_googleplus );
	if ( $googleplus_href !== '' ) {
		$googleplus_target = ( $googleplus_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $googleplus_href['target'] ) ) . '"' : '';
		$googleplus_title  = ( $googleplus_href['title'] !== '' ) ? 'title="' . esc_attr( $googleplus_href['title'] ) . '"' : '';
		if ( ! empty( $googleplus_href['rel'] ) ) {
			$googleplus_rel = ' rel="' . esc_attr( $googleplus_href['rel'] ) . '"';
		} else {
			$googleplus_rel = '';
		}
		if ( ! empty( $googleplus_href['url'] ) ) {
			$output .= '<div class="st-contact-block-socials-item"><a href="' . esc_url( $googleplus_href['url'] ) . '" ' . $googleplus_title . ' ' . $googleplus_target . ' ' . $googleplus_rel . '><i class="fa fa-google-plus" aria-hidden="true"></i></a></div>';
		}
	}
}

if ( $social_pinterest !== '' ) {
	$pinterest_href = vc_build_link( $social_pinterest );
	if ( $pinterest_href['url'] !== '' ) {
		$pinterest_target = ( $pinterest_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $pinterest_href['target'] ) ) . '"' : '';
		$pinterest_title  = ( $pinterest_href['title'] !== '' ) ? 'title="' . esc_attr( $pinterest_href['title'] ) . '"' : '';
		if ( ! empty( $pinterest_href['rel'] ) ) {
			$pinterest_rel = ' rel="' . esc_attr( $pinterest_href['rel'] ) . '"';
		} else {
			$pinterest_rel = '';
		}
		if ( ! empty( $pinterest_href['url'] ) ) {
			$output .= '<div class="st-contact-block-socials-item"><a href="' . esc_url( $pinterest_href['url'] ) . '" ' . $pinterest_title . ' ' . $pinterest_target . ' ' . $pinterest_rel . '><i class="fa fa-pinterest-p" aria-hidden="true"></i></a></div>';
		}
	}
}

if ( $social_linkedin !== '' ) {
	$linkedin_href = vc_build_link( $social_linkedin );
	if ( $linkedin_href !== '' ) {
		$linkedin_target = ( $linkedin_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $linkedin_href['target'] ) ) . '"' : '';
		$linkedin_title  = ( $linkedin_href['title'] !== '' ) ? 'title="' . esc_attr( $linkedin_href['title'] ) . '"' : '';
		if ( ! empty( $linkedin_href['rel'] ) ) {
			$linkedin_rel = ' rel="' . esc_attr( $linkedin_href['rel'] ) . '"';
		} else {
			$linkedin_rel = '';
		}
		if ( ! empty( $linkedin_href['url'] ) ) {
			$output .= '<div class="st-contact-block-socials-item"><a href="' . esc_url( $linkedin_href['url'] ) . '" ' . $linkedin_title . ' ' . $linkedin_target . ' ' . $linkedin_rel . '><i class="fa fa-linkedin" aria-hidden="true"></i></a></div>';
		}
	}
}

if ( $social_instagram !== '' ) {
	$instagram_href = vc_build_link( $social_instagram );
	if ( $instagram_href !== '' ) {
		$instagram_target = ( $instagram_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $instagram_href['target'] ) ) . '"' : '';
		$instagram_title  = ( $instagram_href['title'] !== '' ) ? 'title="' . esc_attr( $instagram_href['title'] ) . '"' : '';
		if ( ! empty( $instagram_href['rel'] ) ) {
			$instagram_rel = ' rel="' . esc_attr( $instagram_href['rel'] ) . '"';
		} else {
			$instagram_rel = '';
		}
		if ( ! empty( $instagram_href['url'] ) ) {
			$output .= '<div class="st-contact-block-socials-item"><a href="' . esc_url( $instagram_href['url'] ) . '" ' . $instagram_title . ' ' . $instagram_target . ' ' . $instagram_rel . '><i class="fa fa-instagram" aria-hidden="true"></i></a></div>';
		}
	}
}

if ( $social_vk !== '' ) {
	$vk_href = vc_build_link( $social_vk );
	if ( $vk_href !== '' ) {
		$vk_target = ( $vk_href['target'] !== '' ) ? 'target="' . esc_attr( trim( $vk_href['target'] ) ) . '"' : '';
		$vk_title  = ( $vk_href['title'] !== '' ) ? 'title="' . esc_attr( $vk_href['title'] ) . '"' : '';
		if ( ! empty( $vk_href['rel'] ) ) {
			$vk_rel = ' rel="' . esc_attr( $vk_href['rel'] ) . '"';
		} else {
			$vk_rel = '';
		}
		if ( ! empty( $instagram_href['url'] ) ) {
			$output .= '<div class="st-contact-block-socials-item"><a href="' . esc_url( $vk_href['url'] ) . '" ' . $vk_title . ' ' . $vk_target . ' ' . $vk_rel . '><i class="fa fa-vk" aria-hidden="true"></i></a></div>';
		}
	}
}

$output .= '</div>'; // st-contact-block-socials
$output .= '</div>'; // st-contact-block-details-inner
$output .= '</div>'; // st-contact-block-details
$output .= '</div>'; // st-contact-block-info

if ( ! empty( $contact_block_table ) ) {
	$output .= '<div class="st-contact-block-table"><table>';
	$output .= '<thead><tr><th>' . esc_attr( $table_first ) . '</th><th>' . esc_attr( $table_second ) . '</th><th>' . esc_attr( $table_third ) . '</th><th>' . esc_attr( $table_fourth ) . '</th><th>' . esc_attr( $table_fifth ) . '</th></tr></thead><tbody>';
	foreach ( $contact_block_table as $contact_block_table_data ) {
		$output .= '<tr>';
		if ( isset( $contact_block_table_data['department'] ) ) {
			$output .= '<td>' . esc_attr( $contact_block_table_data['department'] ) . '</td>';
		}
		if ( isset( $contact_block_table_data['name'] ) ) {
			$output .= '<td>' . esc_attr( $contact_block_table_data['name'] ) . '</td>';
		}
		if ( isset( $contact_block_table_data['phone'] ) ) {
			$output .= '<td class="phone">' . esc_attr( $contact_block_table_data['phone'] ) . '</td>';
		}
		if ( isset( $contact_block_table_data['mail'] ) ) {
			$output .= '<td>' . esc_attr( $contact_block_table_data['mail'] ) . '</td>';
		}
		if ( isset( $contact_block_table_data['skype'] ) ) {
			$output .= '<td>' . esc_attr( $contact_block_table_data['skype'] ) . '</td>';
		}
		$output .= '</tr>';
	}
	$output .= '</tbody></table></div>'; // st-contact-block-table
}
$output .= '<div class="st-contact-block-form-wrapper">';
$output .= '<div class="st-contact-block-form-title"><i class="st-h-before"><i></i></i>' . esc_attr( $contact_form_title ) . '</div>';
$output .= do_shortcode( '[contact-form-7 id="' . $contact_block_cf_id . '"]' );
$output .= '</div>'; // st-contact-block-form-wrapper

if ( $map_scrollwheel == "disable" ) {
	$map_scrollwheel = 'false';
} else {
	$map_scrollwheel = 'true';
}

$output .= '<script type="text/javascript">
jQuery(document).ready(function($){
	"use strict";
	google.maps.event.addDomListener(window, "load", initMap_' . esc_js( $id ) . ');
	var map_' . esc_js( $id ) . ', coordinate_' . esc_js( $id ) . ', marker_' . esc_js( $id ) . ', isDraggable = $(document).width() > 641 ? true : ' . esc_js( $map_dragging ) . ';
	function initMap_' . esc_js( $id ) . '(){
		coordinate_' . esc_js( $id ) . ' = new google.maps.LatLng(' . esc_js( $map_lat ) . ', ' . esc_js( $map_lng ) . ');
		var mapOptions = {
			zoom: ' . esc_js( $map_zoom ) . ',
			center: coordinate_' . esc_js( $id ) . ',
			scaleControl: true,
			streetViewControl: ' . esc_js( $map_streetviewcontrol ) . ',
			mapTypeControl: ' . esc_js( $map_maptypecontrol ) . ',
			panControl: false,
			zoomControl: ' . esc_js( $map_zoomcontrol ) . ',
			scrollwheel: ' . esc_js( $map_scrollwheel ) . ',
			draggable: isDraggable,
			zoomControlOptions: {
				style: google.maps.ZoomControlStyle.' . esc_js( $map_zoomcontrolsize ) . '
			},
			mapTypeId: google.maps.MapTypeId.' . esc_js( $map_type ) . ',
		};
		var mapCanvas = document.getElementById("' . esc_js( $id ) . '");
		map_' . esc_js( $id ) . ' = new google.maps.Map(mapCanvas, mapOptions);
		
		marker_' . esc_js( $id ) . ' = new google.maps.Marker({
			map: map_' . esc_js( $id ) . ',
			position: coordinate_' . esc_js( $id ) . ',
			icon: "' . $icon_url . '"
		});
	}
	
	$("a").on("click", function(){
		setTimeout(function(){
			google.maps.event.trigger(map_' . esc_js( $id ) . ', "resize");
			map_' . esc_js( $id ) . '.setCenter(marker_' . esc_js( $id ) . '.getPosition());
		}, 500);
	});
});
</script>';
$output .= '<div class="st-contact-block-map">';
$output .= '<div class="st-contact-block-map-title"><i class="st-h-before"><i></i></i>' . $map_title . '</div>';
$output .= '<div id="' . esc_attr( $wrap_id ) . '" style="' . ( $map_height != '' ? 'height:' . esc_attr( $map_height ) . ';' : '' ) . '"><div id="' . esc_attr( $id ) . '" ' . ( $map_width != '' || $map_height != '' ? ' style="' . ( $map_width != '' ? 'width:' . esc_attr( $map_width ) . ';' : '' ) . ( $map_height != '' ? 'height:' . esc_attr( $map_height ) . ';' : '' ) . '"' : '' ) . '></div></div>';
$output .= '</div>'; // st-contact-block-map
$output .= '</div>'; // st-contact-block

echo $output;