<?php
$el_class = '';
$output   = '';

$atts = vc_map_get_attributes( $this->getShortcode(), $atts );
extract( $atts );

$el_class                    = isset( $atts['el_class'] ) ? $atts['el_class'] : '';
$id                          = uniqid( 'st-full-width-carousel-' );
$st_full_width_carousel_data = json_decode( urldecode( $st_full_width_carousel_data ), true );

$class_to_filter = 'st-full-width-carousel';
$class_to_filter .= $this->getExtraClass( $el_class );
$css_class       = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $class_to_filter, $this->settings['base'], $atts );

wp_enqueue_script( 'slick' );
if ( is_rtl() ) {
	$rtl = 'rtl:true';
} else {
	$rtl = '';
}

$carousel_script =
	'jQuery(document).ready(function($){
	"use strict";
    $("#' . esc_js( $id ) . '").slick({rows:0, arrows: true,' . $rtl . '});
});
';
wp_add_inline_script( 'slick', $carousel_script );

if ( ! empty( $st_full_width_carousel_data ) ) {
	$output .= '<div id="' . esc_attr( $id ) . '" class="' . esc_attr( $css_class ) . '">';
	$link   = '';
	foreach ( $st_full_width_carousel_data as $st_full_width_carousel_slide ) {
		$href = ! empty( $st_full_width_carousel_slide['link'] ) ? vc_build_link( $st_full_width_carousel_slide['link'] ) : "";
		if ( $href !== "" ) {
			$url        = ( isset( $href['url'] ) && $href['url'] !== '' ) ? $href['url'] : '';
			$target     = ( isset( $href['target'] ) && $href['target'] !== '' ) ? "target='" . trim( $href['target'] ) . "'" : '';
			$link_title = ( isset( $href['title'] ) && $href['title'] !== '' ) ? "title='" . $href['title'] . "'" : '';
			$rel        = ( isset( $href['rel'] ) && $href['rel'] !== '' ) ? "rel='" . $href['rel'] . "'" : '';

			$link .= '<a class="st-full-width-carousel-link" ' . $link_title . ' ' . $rel . ' href = "' . $url . '" ' . $target . '></a>';
		}
		if ( $st_full_width_carousel_slide['image'] !== "" ) {
			$image       = wp_get_attachment_image_src( $st_full_width_carousel_slide['image'], 'full' );
			$image_url   = $image[0];
			$slide_style = 'style="background-image:url(' . esc_url( $image_url ) . ');"';
		}

		$output .= '<div class="st-full-width-carousel-slide" ' . $slide_style . '>';
		$output .= '<div class="st-full-width-carousel-slide-inner">';
		if ( $st_full_width_carousel_slide['subtitle'] !== "" ) {
			$output .= '<div class="st-full-width-carousel-slide-subtitle">' . $st_full_width_carousel_slide['subtitle'] . '</div>';
		}
		if ( $st_full_width_carousel_slide['title'] !== "" ) {
			$output .= '<h3 class="st-full-width-carousel-slide-title">' . $st_full_width_carousel_slide['title'] . '</h3>';
		}
		if ( $st_full_width_carousel_slide['desc'] !== "" ) {
			$output .= '<div class="st-full-width-carousel-slide-desc">' . $st_full_width_carousel_slide['desc'] . '</div>';
		}
		if ( $href !== "" ) {
			$output .= $link;
		}
		$output .= '</div>'; // st-full-width-carousel-slide-inner
		$output .= '</div>'; // st-full-width-carousel-slide
	}
	$output .= '</div>'; // st-full-width-carousel
}

echo $output;