<?php
/*
* Add-on Name: Identity Block Module
*/
if ( ! class_exists( 'St_Identity_Block_Module' ) ) {
	class St_Identity_Block_Module {
		function __construct() {
			add_shortcode( 'st_identity_block', array( $this, 'identity_block_module_shortcode' ) );
			add_action( 'init', array( $this, 'identity_block_module_init' ) );
		}

		function identity_block_module_shortcode( $atts, $content ) {
			$output                 = $identity_block_id = $identity_layout = $identity_bg_image = $identity_bg_color = $identity_company = $identity_title = $identity_subtitle = $icon_type = $icon = $icon_img = $img_width = $icon_size = $icon_color = $module_animation = $animation = $animated = $advantage_box_title_align = $el_class = '';
			$identity_company_font  = $identity_company_font_style = $identity_company_color = $identity_company_font_size = $identity_company_line_height = $identity_company_letter_spacing = '';
			$identity_title_font    = $identity_title_font_style = $identity_title_color = $identity_title_font_size = $identity_title_line_height = $identity_title_letter_spacing = '';
			$identity_subtitle_font = $identity_subtitle_font_style = $identity_subtitle_color = $identity_subtitle_font_size = $identity_subtitle_line_height = $identity_subtitle_letter_spacing = '';
			$identity_desc_font     = $identity_desc_font_size = $identity_desc_line_height = $identity_desc_letter_spacing = $images_data = $overlay_color = $overlay_bg = '';

			extract( shortcode_atts( array(
				'identity_block_id'                => '',
				'identity_layout'                  => '',
				'identity_bg_image'                => '',
				'identity_bg_color'                => '',
				'identity_company'                 => '',
				'identity_title'                   => '',
				'identity_subtitle'                => '',
				'icon_type'                        => '',
				'icon'                             => '',
				'icon_img'                         => '',
				'img_width'                        => '',
				'icon_size'                        => '',
				'icon_color'                       => '',
				'identity_company_font'            => '',
				'identity_company_font_style'      => '',
				'identity_company_color'           => '',
				'identity_company_font_size'       => '',
				'identity_company_line_height'     => '',
				'identity_company_letter_spacing'  => '',
				'identity_title_font'              => '',
				'identity_title_font_style'        => '',
				'identity_title_color'             => '',
				'identity_title_font_size'         => '',
				'identity_title_line_height'       => '',
				'identity_title_letter_spacing'    => '',
				'identity_subtitle_font'           => '',
				'identity_subtitle_font_style'     => '',
				'identity_subtitle_color'          => '',
				'identity_subtitle_font_size'      => '',
				'identity_subtitle_line_height'    => '',
				'identity_subtitle_letter_spacing' => '',
				'identity_desc_font'               => '',
				'identity_desc_font_size'          => '',
				'identity_desc_line_height'        => '',
				'identity_desc_letter_spacing'     => '',
				'images_data'                      => '',
				'title'                            => '',
				'image'                            => '',
				'link'                             => '',
				'overlay_color'                    => '',
				'module_animation'                 => '',
				'el_class'                         => '',
			), $atts ) );


			// Animation TODO :
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$id = uniqid( 'st-identity-block-' );

			$images_data = json_decode( urldecode( $images_data ), true );

			if ( ! empty( $identity_block_id ) ) {
				$identity_id = 'id="' . esc_attr( $identity_block_id ) . '"';
			}

			if ( empty( $identity_layout ) ) {
				$identity_layout = 'identity-first';
			}

			if ( isset( $identity_bg_image ) ) {
				$bg_img   = wp_get_attachment_image_src( $atts['identity_bg_image'], 'full' );
				$bg       = $bg_img[0];
				$bg_style = 'style="background-image:url(' . esc_url( $bg ) . ')"';
			}

			if ( $identity_bg_color ) {
				$info_bg_style = 'style="background-color:' . esc_attr( $identity_bg_color ) . '"';
			}

			if ( $overlay_color ) {
				$overlay_bg = 'style="background-color:' . esc_attr( $overlay_color ) . '"';
			}

			// Company
			$identity_company_style = 'style="';

			if ( $identity_company_font !== '' ) {
				$identity_company_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $identity_company_font ) : '';
				$identity_company_style       .= ! empty( $identity_company_font_family ) ? 'font-family:\'' . $identity_company_font_family . '\';' : '';
			}
			if ( $identity_company_font_style !== '' ) {
				$identity_company_style .= esc_attr( $identity_company_font_style );
			}

			if ( is_numeric( $identity_company_font_size ) ) {
				$identity_company_font_size = 'desktop: ' . $identity_company_font_size . 'px;';
			}
			if ( is_numeric( $identity_company_line_height ) ) {
				$identity_company_line_height = 'desktop: ' . $identity_company_line_height . 'px;';
			}

			$identity_company_args = array(
				'target'      => '#' . $id . ' .st-identity-block-company',
				'media_sizes' => array(
					'font-size'   => $identity_company_font_size,
					'line-height' => $identity_company_line_height,
				),
			);

			$identity_company_responsive = get_ultimate_vc_responsive_media_css( $identity_company_args );
			$identity_company_style      .= $identity_company_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $identity_company_letter_spacing ) . 'px;' : '';
			$identity_company_style      .= $identity_company_color !== '' ? 'color:' . esc_attr( $identity_company_color ) . ';' : '';
			$identity_company_style      .= '"';

			// Title
			$identity_title_style = 'style="';

			if ( $identity_title_font !== '' ) {
				$identity_title_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $identity_title_font ) : '';
				$identity_title_style       .= ! empty( $identity_title_font_family ) ? 'font-family:\'' . $identity_title_font_family . '\';' : '';
			}
			if ( $identity_title_font_style !== '' ) {
				$identity_title_style .= esc_attr( $identity_title_font_style );
			}

			if ( is_numeric( $identity_title_font_size ) ) {
				$identity_title_font_size = 'desktop: ' . $identity_title_font_size . 'px;';
			}
			if ( is_numeric( $identity_title_line_height ) ) {
				$identity_title_line_height = 'desktop: ' . $identity_title_line_height . 'px;';
			}

			$identity_title_args = array(
				'target'      => '#' . $id . ' .st-identity-block-title',
				'media_sizes' => array(
					'font-size'   => $identity_title_font_size,
					'line-height' => $identity_title_line_height,
				),
			);

			$identity_title_responsive = get_ultimate_vc_responsive_media_css( $identity_title_args );
			$identity_title_style      .= $identity_title_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $identity_title_letter_spacing ) . 'px;' : '';
			$identity_title_style      .= $identity_title_color !== '' ? 'color:' . esc_attr( $identity_title_color ) . ';' : '';
			$identity_title_style      .= '"';

			// Subtitle
			$identity_subtitle_style = 'style="';

			if ( $identity_subtitle_font !== '' ) {
				$identity_subtitle_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $identity_subtitle_font ) : '';
				$identity_subtitle_style       .= ! empty( $identity_subtitle_font_family ) ? 'font-family:\'' . $identity_subtitle_font_family . '\';' : '';
			}
			if ( $identity_subtitle_font_style !== '' ) {
				$identity_subtitle_style .= esc_attr( $identity_subtitle_font_style );
			}

			if ( is_numeric( $identity_subtitle_font_size ) ) {
				$identity_subtitle_font_size = 'desktop: ' . $identity_subtitle_font_size . 'px;';
			}
			if ( is_numeric( $identity_subtitle_line_height ) ) {
				$identity_subtitle_line_height = 'desktop: ' . $identity_subtitle_line_height . 'px;';
			}

			$identity_subtitle_args = array(
				'target'      => '#' . $id . ' .st-identity-block-subtitle',
				'media_sizes' => array(
					'font-size'   => $identity_subtitle_font_size,
					'line-height' => $identity_subtitle_line_height,
				),
			);

			$identity_subtitle_responsive = get_ultimate_vc_responsive_media_css( $identity_subtitle_args );
			$identity_subtitle_style      .= $identity_subtitle_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $identity_subtitle_letter_spacing ) . 'px;' : '';
			$identity_subtitle_style      .= $identity_subtitle_color !== '' ? 'color:' . esc_attr( $identity_subtitle_color ) . ';' : '';
			$identity_subtitle_style      .= '"';

			// Description
			$identity_desc_style = 'style="';

			if ( $identity_desc_font !== '' ) {
				$identity_desc_font_family = function_exists( 'get_ultimate_font_family' ) ? get_ultimate_font_family( $identity_desc_font ) : '';
				$identity_desc_style       .= ! empty( $identity_desc_font_family ) ? 'font-family:\'' . $identity_desc_font_family . '\';' : '';
			}

			if ( is_numeric( $identity_desc_font_size ) ) {
				$identity_desc_font_size = 'desktop: ' . $identity_desc_font_size . 'px;';
			}
			if ( is_numeric( $identity_desc_line_height ) ) {
				$identity_desc_line_height = 'desktop: ' . $identity_desc_line_height . 'px;';
			}

			$identity_desc_args = array(
				'target'      => '#' . $id . ' .st-identity-block-desc',
				'media_sizes' => array(
					'font-size'   => $identity_desc_font_size,
					'line-height' => $identity_desc_line_height,
				),
			);

			$identity_desc_responsive = get_ultimate_vc_responsive_media_css( $identity_desc_args );
			$identity_desc_style      .= $identity_desc_letter_spacing !== '' ? 'letter-spacing:' . esc_attr( $identity_desc_letter_spacing ) . 'px;' : '';
			$identity_desc_style      .= '"';

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-identity-block ' . esc_attr( $el_class ) . ' ' . esc_attr( $identity_layout ) . '" ' . $identity_id . '>';
			$output .= '<div class="st-identity-block-inner" id="' . esc_attr( $id ) . '">';
			$output .= '<div class="st-identity-block-top" ' . $bg_style . '>';
			$output .= '<div class="st-identity-block-info-wrapper" ' . $info_bg_style . '>';
			if ( $identity_company ) {
				$output .= '<div class="st-identity-block-company ult-responsive ' . esc_attr( $animated ) . '" ' . $animation . ' ' . $identity_company_style . ' ' . $identity_company_responsive . '>' . esc_attr( $identity_company ) . '</div>';
			}
			$output .= '<div class="st-identity-block-title-wrapper">';
			$output .= '<div class="st-identity-block-icon-wrapper">';
			if ( $icon_type == 'custom' ) {
				$img = apply_filters( 'ult_get_img_single', $icon_img, 'url' );
				$alt = apply_filters( 'ult_get_img_single', $icon_img, 'alt' );
				if ( ! empty( $img_width ) ) {
					$icon_img_style = ' style="font-size:' . esc_attr( $img_width ) . 'px"';
				}

				if ( ! empty( $img ) ) {
					$output .= '<div class="st-identity-block-icon-img"' . $icon_img_style . '>';
					$output .= '<img src="' . esc_url( $img ) . '" alt="' . esc_attr( $alt ) . '"/>';
					$output .= '</div>'; // st-identity-block-icon-img
				}
			} else {
				$icon_style = '';
				if ( $icon_color !== '' ) {
					$icon_style .= 'color:' . esc_attr( $icon_color ) . ';';
				}
				if ( $icon_size !== '' ) {
					$icon_style .= 'font-size:' . esc_attr( $icon_size ) . 'px; height:' . esc_attr( $icon_size ) . 'px';
				}
				if ( $icon !== '' ) {
					$output .= '<div class="st-identity-block-icon" style="' . $icon_style . '">';
					$output .= '<i class="' . esc_attr( $icon ) . '"></i>';
					$output .= '</div>'; // st-identity-block-icon-img
				}
			}
			$output .= '</div>'; // st-identity-block-icon-wrapper
			$output .= '<h2 class="st-identity-block-title ult-responsive ' . esc_attr( $animated ) . '" ' . $animation . ' ' . $identity_title_style . ' ' . $identity_title_responsive . '>' . esc_attr( $identity_title ) . '</h2>';
			$output .= '</div>'; // st-identity-block-title-wrapper
			$output .= '<div class="st-identity-block-subtitle ult-responsive ' . esc_attr( $animated ) . '" ' . $animation . ' ' . $identity_subtitle_style . ' ' . $identity_subtitle_responsive . '>' . esc_attr( $identity_subtitle ) . '</div>';
			$output .= '</div>'; // st-identity-block-info-wrapper
			$output .= '</div>'; // st-identity-block-top
			$output .= '<div class="st-identity-block-bottom ' . esc_attr( $animated ) . '" ' . $animation . '>';
			$output .= '<div class="st-identity-block-desc ult-responsive" ' . $identity_desc_style . ' ' . $identity_desc_responsive . '>' . do_shortcode( $content ) . '</div>';
			$output .= '<div class="st-identity-block-gallery" id="' . esc_attr( $id ) . '-gallery">';
			if ( isset( $images_data ) ) {
				foreach ( $images_data as $images_datas ) {
					$output .= '<div class="st-identity-block-image">';

					$image_link        = $images_datas['link'];
					$link              = vc_build_link( $image_link );
					$link_title        = $link['title'];
					$link_url          = $link['url'];
					$link_target       = $link['target'];
					$pretty_rel_random = ' data-rel="prettyPhoto[rel-' . get_the_ID() . '-' . rand() . ']"';

					if ( $link_target ) {
						$target = ' target="' . esc_attr( $link_target ) . '"';
					} else {
						$target = '';
					}

					if ( ! empty( $link['rel'] ) ) {
						$rel = ' rel="' . esc_attr( $link['rel'] ) . '"';
					} else {
						$rel = '';
					}

					if ( isset( $images_datas['image'] ) ) {
						$img = wp_get_attachment_image_src( $images_datas['image'], 'full' );
					}

					if ( ! empty( $link_url ) ) {
						$output .= '<a class="st-identity-block-image-link" href="' . esc_url( $link_url ) . '" ' . $target . ' title="' . esc_attr( $link['title'] ) . '" ' . $rel . '>';
					} else {
						$output .= '<a rel="prettyPhoto" href="' . esc_url( $img[0] ) . '"' . $pretty_rel_random . '>';
					}
					$output .= '<div class="st-identity-block-image-overlay" ' . $overlay_bg . '>';
					if ( isset( $images_datas['title'] ) ) {
						$output .= '<div class="st-identity-image-title">' . $images_datas['title'] . '</div>';
					}
					$output .= '<div class="overlay-inner-left"></div>';
					$output .= '<div class="overlay-inner-right"></div>';
					$output .= '</div>'; // st-identity-block-image-overlay
					if ( isset( $images_datas['image'] ) ) {
						$img      = wp_get_attachment_image_src( $images_datas['image'], 'full' );
						$img_alt  = strip_tags( get_post_meta( $images_datas['image'], '_wp_attachment_image_alt', true ) );
						$img_link = $img[0];
						$image    = st_adamas_aq_resize( $img_link, 640, 550, true, true, true );
						if ( ! $image ) {
							$image = $img_link;
						}
						$output .= '<img src="' . esc_url( $image ) . '" alt="' . esc_attr( $img_alt ) . '" />';
					}
					$output .= '</a>';
					$output .= '</div>'; // st-product-carousel-item
				}
			}
			$output .= '</div>';
			$output .= '</div>'; // st-identity-block-bottom
			$output .= '</div>'; // st-identity-block-inner
			$output .= '</div>'; // st-identity-block

			return $output;
		}

		function identity_block_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Identity block', 'adamas-vc-shortcodes' ),
					'base'        => 'st_identity_block',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/identity_block.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays identity block', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Identity block ID', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_block_id',
							'description' => __( 'Please, set unique ID for this module due to W3C specification.', 'adamas-vc-shortcodes' ),
						),
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Identity block layout', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_layout',
							'value'       => array(
								__( 'Title block and description right, icon left', 'adamas-vc-shortcodes' ) => 'identity-first',
								__( 'Title block and description left, icon right', 'adamas-vc-shortcodes' ) => 'identity-second',
							),
							'description' => ''
						),
						array(
							'type'        => 'attach_image',
							'class'       => '',
							'heading'     => __( 'Background image', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_bg_image',
							'description' => ''
						),
						array(
							'type'        => 'colorpicker',
							'class'       => '',
							'heading'     => __( 'Background color for title block', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_bg_color',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Company name', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_company',
							'description' => ''
						),
						array(
							'type'        => 'textfield',
							'class'       => '',
							'heading'     => __( 'Title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_title',
							'description' => '',
							'admin_label' => true
						),
						array(
							'type'        => 'textarea',
							'class'       => '',
							'heading'     => __( 'Subtitle', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_subtitle',
							'description' => ''
						),
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Icon to display:', 'adamas-vc-shortcodes' ),
							'param_name'  => 'icon_type',
							'value'       => array(
								__( 'Font Icon Manager', 'adamas-vc-shortcodes' ) => 'selector',
								__( 'Custom Image Icon', 'adamas-vc-shortcodes' ) => 'custom',
							),
							'description' => __( 'Use an existing font icon or upload a custom image.', 'adamas-vc-shortcodes' )
						),
						array(
							'type'        => 'icon_manager',
							'class'       => '',
							'heading'     => __( 'Select Icon', 'adamas-vc-shortcodes' ),
							'param_name'  => 'icon',
							'value'       => '',
							'description' => __( "Click and select icon of your choice. If you can't find the one that suits for your purpose", "adamas-vc-shortcodes" ) . ", " . __( "you can", "adamas-vc-shortcodes" ) . " <a href='admin.php?page=bsf-font-icon-manager' target='_blank'>" . __( "add new here", "adamas-vc-shortcodes" ) . "</a>.",
							'dependency'  => Array( 'element' => 'icon_type', 'value' => array( 'selector' ) ),
						),
						array(
							'type'        => 'ult_img_single',
							'class'       => '',
							'heading'     => __( 'Upload Image Icon:', 'adamas-vc-shortcodes' ),
							'param_name'  => 'icon_img',
							'value'       => '',
							'description' => __( 'Upload the custom image icon.', 'adamas-vc-shortcodes' ),
							'dependency'  => Array( 'element' => 'icon_type', 'value' => array( 'custom' ) ),
						),
						array(
							'type'        => 'number',
							'class'       => '',
							'heading'     => __( 'Image Width', 'adamas-vc-shortcodes' ),
							'param_name'  => 'img_width',
							'value'       => 150,
							'min'         => 50,
							'max'         => 300,
							'suffix'      => 'px',
							'description' => __( 'Provide image width', 'adamas-vc-shortcodes' ),
							'dependency'  => Array( 'element' => 'icon_type', 'value' => array( 'custom' ) ),
						),
						array(
							'type'        => 'number',
							'class'       => '',
							'heading'     => __( 'Size of Icon', 'adamas-vc-shortcodes' ),
							'param_name'  => 'icon_size',
							'value'       => 150,
							'min'         => 50,
							'max'         => 300,
							'suffix'      => 'px',
							'description' => __( 'How big would you like it?', 'adamas-vc-shortcodes' ),
							'dependency'  => Array( 'element' => 'icon_type', 'value' => array( 'selector' ) ),
						),
						array(
							'type'        => 'colorpicker',
							'class'       => '',
							'heading'     => __( 'Color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'icon_color',
							'value'       => '#333333',
							'description' => __( 'Give it a nice paint!', 'adamas-vc-shortcodes' ),
							'dependency'  => Array( 'element' => 'icon_type', 'value' => array( 'selector' ) ),
						),
						array(
							'type'        => 'textarea_html',
							'class'       => '',
							'heading'     => __( 'Description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => ''
						),
						array(
							'type'        => 'colorpicker',
							'class'       => '',
							'heading'     => __( 'Background color for images overlay', 'adamas-vc-shortcodes' ),
							'param_name'  => 'overlay_color',
							'description' => ''
						),
						array(
							'type'        => 'param_group',
							'heading'     => __( 'Images', 'adamas-vc-shortcodes' ),
							'param_name'  => 'images_data',
							'description' => __( 'Add products here.', 'adamas-vc-shortcodes' ),
							'value'       => urlencode( json_encode( array(
								array(
									'title' => '',
									'image' => '',
									'link'  => '',
								)
							) ) ),
							'params'      => array(
								array(
									'type'        => 'textfield',
									'heading'     => __( 'Title', 'adamas-vc-shortcodes' ),
									'param_name'  => 'title',
									'admin_label' => true,
								),
								array(
									'type'       => 'attach_image',
									'heading'    => __( 'Image', 'adamas-vc-shortcodes' ),
									'param_name' => 'image',
								),
								array(
									'type'       => 'vc_link',
									'heading'    => __( 'Link', 'adamas-vc-shortcodes' ),
									'param_name' => 'link',
									'value'      => '',
								),
							),
						),

						// Company name typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Company font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_company_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Company font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_company_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Company font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_company_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Company font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_company_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Company line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_company_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Company letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_company_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Title typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Title font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_title_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Title font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_title_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Title font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_title_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_title_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Title line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_title_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Title letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_title_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Subtitle typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Subtitle font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_subtitle_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_google_fonts_style',
							'heading'     => __( 'Subtitle font style', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_subtitle_font_style',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'colorpicker',
							'heading'     => __( 'Subtitle font color', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_subtitle_color',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Subtitle font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_subtitle_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Subtitle line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_subtitle_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Subtitle letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_subtitle_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Description typography
						array(
							'type'        => 'ultimate_google_fonts',
							'heading'     => __( 'Description font family', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_desc_font',
							'value'       => '',
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description font size', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_desc_font_size',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'ultimate_responsive',
							'class'       => 'font-size',
							'heading'     => __( 'Description line height', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_desc_line_height',
							'unit'        => 'px',
							'media'       => array(
								"Desktop"          => '',
								"Tablet"           => '',
								"Tablet Portrait"  => '',
								"Mobile Landscape" => '',
								"Mobile"           => '',
							),
							'description' => '',
							'group'       => 'Typography',
						),
						array(
							'type'        => 'number',
							'heading'     => __( 'Description letter spacing', 'adamas-vc-shortcodes' ),
							'param_name'  => 'identity_desc_letter_spacing',
							'value'       => '',
							'description' => '',
							'suffix'      => 'px',
							'group'       => 'Typography',
						),

						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_identity_block_module = new St_Identity_Block_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_identity_block_module extends WPBakeryShortCode {
		}
	}
}