<?php
/*
* Add-on Name: Simple Price Box Module
*/
if ( ! class_exists( 'St_Simple_Price_Box_Module' ) ) {
	class St_Simple_Price_Box_Module {
		function __construct() {
			add_shortcode( 'st_simple_price_box_module', array( $this, 'simple_price_box_module_shortcode' ) );
			add_action( 'init', array( $this, 'simple_price_box_module_init' ) );
		}

		function simple_price_box_module_shortcode( $atts, $content ) {
			$output = $price_box_title = $price_box_price = $module_animation = $animation = $animated = $el_class = '';

			extract( shortcode_atts( array(
				'price_box_title'  => '',
				'price_box_price'  => '',
				'module_animation' => '',
				'el_class'         => '',
			), $atts ) );

			// Animation
			if ( $module_animation ) {
				$animated  .= ' st-animation';
				$animation .= 'data-animation="' . esc_attr( $module_animation ) . '"';
			}

			$content = wpb_js_remove_wpautop( $content, true );

			$output .= '<div class="st-simple-price-box ' . esc_attr( $el_class ) . ' ' . esc_attr( $animated ) . '" ' . $animation . '>';
			$output .= '<div class="st-simple-price-box-inner">';
			$output .= '<div class="st-simple-price-box-title"><h4>' . esc_attr( $price_box_title ) . '</h4></div>';
			$output .= '<div class="st-simple-price-box-sep"><hr class="st-simple-price-box-between"></div>';
			$output .= '<div class="st-simple-price-box-price">' . esc_attr( $price_box_price ) . '</div>';
			$output .= '</div>'; // st-simple-price-box-inner
			$output .= '<div class="st-simple-price-box-desc">' . do_shortcode( $content ) . '</div>';
			$output .= '</div>'; // st-simple-price-box

			return $output;
		}

		function simple_price_box_module_init() {
			if ( function_exists( 'vc_map' ) ) {
				vc_map( array(
					'name'        => __( 'Simple Price Box', 'adamas-vc-shortcodes' ),
					'base'        => 'st_simple_price_box_module',
					'icon'        => get_template_directory_uri() . '/assets/images/shortcode_icons/simple_price_box.png',
					'category'    => __( 'ST Addons', 'adamas-vc-shortcodes' ),
					'description' => __( 'Displays simple price box', 'adamas-vc-shortcodes' ),
					'params'      => array(
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Price box title', 'adamas-vc-shortcodes' ),
							'param_name'  => 'price_box_title',
							'description' => '',
							'admin_label' => true,
						),
						array(
							'type'        => 'textfield',
							'heading'     => __( 'Price', 'adamas-vc-shortcodes' ),
							'param_name'  => 'price_box_price',
							'description' => '',
						),
						array(
							'type'        => 'textarea_html',
							'heading'     => __( 'Price box description', 'adamas-vc-shortcodes' ),
							'param_name'  => 'content',
							'description' => '',
						),
						// Animation
						array(
							'type'        => 'dropdown',
							'class'       => '',
							'heading'     => __( 'Animation', 'adamas-vc-shortcodes' ),
							'param_name'  => 'module_animation',
							'value'       => st_adamas_animations_list(),
							'description' => __( 'Select appearance animation for this element.', 'adamas-vc-shortcodes' ),
						),
					)
				) );
			}
		}
	}

	$st_simple_price_box_module = new St_Simple_Price_Box_Module;
	if ( class_exists( 'WPBakeryShortCode' ) ) {
		class WPBakeryShortCode_st_simple_price_box_module extends WPBakeryShortCode {
		}
	}
}