/*
 * Portfolio Isotope
 */
(function ($) {
    "use strict";
    $.fn.StPortfolioModule = (function (portfolio_layout) {
        if (!portfolio_layout || portfolio_layout === '')
            portfolio_layout = 'fitRows';

        var $window = $(window);
        var $portfolio = $('.st-portfolio-items');
        var isotopeInit;
        if ($('body').hasClass('rtl')) {
            isotopeInit = function () {
                $portfolio.isotope({
                    isOriginLeft: false,
                    layoutMode: portfolio_layout,
                    masonry: {},
                    itemSelector: '.st-portfolio-item',
                    resizable: true,
                    percentPosition: true
                });
                $.fn.matchHeight._update();
            };
        } else {
            isotopeInit = function () {
                $portfolio.isotope({
                    layoutMode: portfolio_layout,
                    masonry: {},
                    itemSelector: '.st-portfolio-item',
                    resizable: true,
                    percentPosition: true
                });
                $.fn.matchHeight._update();
            };
        }

        $portfolio.imagesLoaded(function () {
            isotopeInit();
        });

        $window.on('load', isotopeInit);
        $window.on('resize', isotopeInit);

        $('.st-portfolio-filter-panel .st-portfolio-filters a').click(function () {
            var filterValue = $(this).attr('data-filter');
            $(this).parent().parent().find('> li.active').removeClass('active');
            $(this).parent().addClass('active');
            $portfolio.isotope({filter: filterValue});
            $portfolio.isotope('layout');
            return false;
        });
    });
})(jQuery);