<?php
/*
 * Styles and scripts
 */

if ( ! function_exists( 'st_adamas_styles_scripts_init' ) ) {
	function st_adamas_styles_scripts_init() {
		global $st_adamas;

		$st_multisite = st_adamas_multisite();

		// Theme Styles
		wp_enqueue_style( 'st-adamas-main', get_template_directory_uri() . '/assets/css/main' . $st_multisite . '.css', false, null );
		wp_enqueue_style( 'font-awesome', get_template_directory_uri() . '/assets/css/font-awesome.min.css', false, null );
		wp_enqueue_style( 'linea-basic', get_template_directory_uri() . '/assets/css/linea-basic.css', false, null );
		if ( class_exists( 'Vc_Manager', false ) ) {
			wp_enqueue_style( 'st-adamas-composer', get_template_directory_uri() . '/assets/css/composer' . $st_multisite . '.css', array(), false, 'all' );
		}
		if ( isset( $st_adamas['animsition_enable'] ) && ( $st_adamas['animsition_enable'] ) == 1 ):
			wp_enqueue_style( 'animsition', get_template_directory_uri() . '/assets/css/animsition.min.css', false, null );
		endif;
		wp_enqueue_style( 'select2-min', get_template_directory_uri() . '/assets/css/select2.min.css', false, null );
		if ( class_exists( 'WooCommerce' ) ) {
			wp_enqueue_style( 'st-adamas-woocommmerce', get_template_directory_uri() . '/assets/css/woocommerce' . $st_multisite . '.css', false, null );
		}
		wp_enqueue_style( 'st-adamas-responsive', get_template_directory_uri() . '/assets/css/responsive' . $st_multisite . '.css', false, null );

		// RTL support
		$rtl = '';
		if ( is_rtl() ) {
			wp_enqueue_style( 'st-adamas-rtl', get_template_directory_uri() . '/assets/css/rtl.css', false, null );
			$rtl = 'rtl:true';
		}

		// Custom CSS
		if ( isset( $st_adamas['custom_css'] ) && $st_adamas['custom_css'] ) {
			$custom_css = $st_adamas['custom_css'];
			wp_add_inline_style( 'st-adamas-main', $custom_css );
		}

		// Theme Scripts
		wp_enqueue_script( 'imagesloaded', get_template_directory_uri() . '/assets/js/imagesloaded.pkgd.min.js', false, null, true );
		wp_enqueue_script( 'jquery-matchHeight', get_template_directory_uri() . '/assets/js/jquery.matchHeight.js', array( 'jquery' ), null, true );
		wp_enqueue_script( 'jquery-sidr', get_template_directory_uri() . '/assets/js/jquery.sidr.min.js', array( 'jquery' ), null, true );
		wp_enqueue_script( 'bluebird', get_template_directory_uri() . '/assets/js/bluebird.min.js', array( 'jquery' ), null, true );
		wp_enqueue_script( 'jquery-waypoints', get_template_directory_uri() . '/assets/js/jquery.waypoints.min.js', array( 'jquery' ), null, true );
		wp_enqueue_script( 'velocity', get_template_directory_uri() . '/assets/js/velocity.min.js', false, null, true );
		wp_enqueue_script( 'velocity-ui', get_template_directory_uri() . '/assets/js/velocity.ui.min.js', false, null, true );
		wp_enqueue_script( 'jquery-prettyPhoto', get_template_directory_uri() . '/assets/js/jquery.prettyPhoto.js', array( 'jquery' ), null, true );
		if ( isset( $st_adamas['animsition_enable'] ) && ( $st_adamas['animsition_enable'] ) == 1 ):
			wp_enqueue_script( 'animsition', get_template_directory_uri() . '/assets/js/animsition.min.js', false, null, true );
		endif;
		wp_enqueue_script( 'jssocials', get_template_directory_uri() . '/assets/js/jssocials.min.js', array( 'jquery' ), false, true );
		wp_enqueue_script( 'slick', get_template_directory_uri() . '/assets/js/slick.min.js', false, null, true );
		wp_enqueue_script( 'select2-full', get_template_directory_uri() . '/assets/js/select2.full.min.js', array( 'jquery' ), false, true );
		wp_enqueue_script( 'isotope', get_template_directory_uri() . '/assets/js/isotope.pkgd.min.js', false, null, true );
		wp_enqueue_script( 'st-adamas-blog-masonry', get_template_directory_uri() . '/assets/js/blog.masonry.js', array(
			'jquery',
			'isotope'
		), null, true );
		wp_enqueue_script( 'st-adamas-main', get_template_directory_uri() . '/assets/js/main.js', array( 'jquery' ), null, true );

		if ( is_single() ) {
			wp_enqueue_script( 'st-adamas-posts-related', get_template_directory_uri() . '/assets/js/posts.related.js', array(
				'jquery',
				'isotope'
			), null, true );
		}

		if ( class_exists( 'woocommerce' ) && ( is_shop() || is_product_category() || is_product_tag() || is_product_taxonomy() || is_cart() || is_product() ) ) {
			wp_enqueue_script( 'st-adamas-shop-masonry', get_template_directory_uri() . '/assets/js/shop.masonry.js', array(
				'jquery',
				'isotope'
			), null, true );
		}

		// Smooth scroll
		if ( isset( $st_adamas['smoothscroll_enable'] ) && ( $st_adamas['smoothscroll_enable'] ) == 1 ):
			wp_enqueue_script( 'smoothscroll', get_template_directory_uri() . '/assets/js/smoothscroll.js', false, null, true );
		endif;

		// Custom JS
		if ( isset( $st_adamas['custom_js'] ) && $st_adamas['custom_js'] ) {
			$custom_js = $st_adamas['custom_js'];
			wp_add_inline_script( 'st-adamas-main', $custom_js );
		}

		// Script translations
		$translate = array(
			'hide'            => esc_html__( 'Hide', 'adamas' ),
			'more_info'       => esc_html__( 'More info', 'adamas' ),
			'read'            => esc_html__( 'READ', 'adamas' ),
			'more'            => esc_html__( 'MORE', 'adamas' ),
			'quick_view'      => esc_html__( 'Quick view', 'adamas' ),
			'add_to_cart'     => esc_html__( 'Add to cart', 'adamas' ),
			'view_cart'       => esc_html__( 'View cart', 'adamas' ),
			'read_more'       => esc_html__( 'Read more', 'adamas' ),
			'view_products'   => esc_html__( 'View products', 'adamas' ),
			'add_to_wishlist' => esc_html__( 'Add to wishlist', 'adamas' ),
			'wishlist'        => esc_html__( 'Wishlist', 'adamas' ),
			'compare'         => esc_html__( 'Compare', 'adamas' ),
			'rtl'             => $rtl,
		);
		wp_localize_script( 'st-adamas-main', 'st_localize_script', $translate );
	}
}

// Admin script and styles enqueue
if ( ! function_exists( 'st_adamas_admin_css_init' ) ) {
	function st_adamas_admin_css_init() {
		wp_enqueue_style( 'st-adamas-admin-panel', get_template_directory_uri() . '/assets/css/admin-panel.css' );
	}
}