<?php get_header(); ?>

<?php
global $st_adamas, $wp_query;

$archive_layout = isset( $st_adamas['archive_layout'] ) ? $st_adamas['archive_layout'] : '';

if ( ! isset( $st_adamas['archive_sidebar'] ) && empty( $st_adamas['archive_sidebar'] ) ) {
	$sidebar = 'right';
}
if ( ! isset( $st_adamas['archive_page_layout'] ) && empty( $st_adamas['archive_page_layout'] ) ) {
	$archive_page_layout = 'archive-list';
}
if ( ! isset( $st_adamas['archive_grid_column_amount'] ) && empty( $st_adamas['archive_grid_column_amount'] ) ) {
	$archive_grid_column_amount = 'two-column';
}

if ( isset( $st_adamas['archive_page_layout'] ) && ! empty( $st_adamas['archive_page_layout'] ) ) {
	$archive_page_layout = $st_adamas['archive_page_layout'];
}
if ( isset( $st_adamas['archive_sidebar'] ) && ! empty( $st_adamas['archive_sidebar'] ) ) {
	$sidebar = $st_adamas['archive_sidebar'];
}
if ( isset( $st_adamas['archive_grid_column_amount'] ) && ! empty( $st_adamas['archive_grid_column_amount'] ) ) {
	$archive_grid_column_amount = $st_adamas['archive_grid_column_amount'];
}
if ( $archive_page_layout === 'archive-list' ) {
	$archive_grid_column_amount = '';
}

?>

<?php get_template_part( 'templates/title' ); ?>

    <section id="layout-container"
             class="<?php echo esc_attr( $archive_page_layout ); ?> <?php echo esc_attr( $archive_layout ); ?>">
        <div class="row">

			<?php
			if ( $sidebar == 'left' ) {
				get_template_part( 'templates/sidebar/sidebar', $sidebar );
			} ?>
			<?php if ( $sidebar == 'no-sidebar' ){ ?>
            <div class="st-12 col <?php echo esc_attr( $archive_grid_column_amount ); ?>">
				<?php } else { ?>
                <div class="st-9 col <?php echo esc_attr( $archive_grid_column_amount ); ?> sidebar">
					<?php } ?>
                    <div class="blog-articles">
						<?php if ( (int) $wp_query->found_posts === 0 ) {

							esc_html_e( 'Nothing found. Try another search query.', 'adamas' );

						} else {

							if ( have_posts() ) :
								while ( have_posts() ) : the_post();
									get_template_part( 'templates/content', 'search' );
								endwhile;
							endif;

						}
						?>
                    </div>
                </div>
				<?php
				if ( $sidebar === 'right' ) {
					get_template_part( 'templates/sidebar/sidebar', $sidebar );
				}
				?>
            </div>

    </section>

<?php if ( ! is_page_template( 'page-templates/blank-page.php' ) ) { ?>
	<?php get_footer(); ?>
<?php }