<?php

global $st_adamas;

if ( ! isset( $st_adamas['blog_page_layout'] ) && empty( $st_adamas['blog_page_layout'] ) ) {
	$blog_page_layout = 'blog-list';
}
if ( ! isset( $st_adamas['blog_grid_column_amount'] ) && empty( $st_adamas['blog_grid_column_amount'] ) ) {
	$blog_grid_column_amount = 'two-column';
}

if ( isset( $st_adamas['blog_page_layout'] ) && ! empty( $st_adamas['blog_page_layout'] ) ) {
	$blog_page_layout = $st_adamas['blog_page_layout'];
}
if ( isset( $st_adamas['blog_grid_column_amount'] ) && ! empty( $st_adamas['blog_grid_column_amount'] ) ) {
	$blog_grid_column_amount = $st_adamas['blog_grid_column_amount'];
}

if ( $blog_page_layout == 'blog-grid' && $blog_grid_column_amount == 'two-column' ) {
	$width  = 900;
	$height = 500;
}
if ( $blog_page_layout == 'blog-grid' && $blog_grid_column_amount == 'three-column' ) {
	$width  = 400;
	$height = 300;
}
if ( $blog_page_layout == 'blog-grid' && $blog_grid_column_amount == 'four-column' ) {
	$width  = 300;
	$height = 220;
}

if ( $blog_page_layout == 'blog-list' ) {
	$blog_grid_column_amount = '';
	$width                   = 900;
	$height                  = 400;
}

if ( is_archive() || is_search() ) {
	if ( isset( $st_adamas['archive_page_layout'] ) && ! empty( $st_adamas['archive_page_layout'] ) ) {
		$archive_page_layout = $st_adamas['archive_page_layout'];
	}
	if ( isset( $st_adamas['archive_grid_column_amount'] ) && ! empty( $st_adamas['archive_grid_column_amount'] ) ) {
		$archive_grid_column_amount = $st_adamas['archive_grid_column_amount'];
	}

	if ( $archive_page_layout == 'archive-grid' && $archive_grid_column_amount == 'two-column' ) {
		$width  = 430;
		$height = 300;
	}
	if ( $archive_page_layout == 'archive-grid' && $archive_grid_column_amount == 'three-column' ) {
		$width  = 400;
		$height = 300;
	}
	if ( $archive_page_layout == 'archive-grid' && $archive_grid_column_amount == 'four-column' ) {
		$width  = 300;
		$height = 250;
	}
	if ( $archive_page_layout == 'archive-list' ) {
		$archive_grid_column_amount = '';
		$width                      = 900;
		$height                     = 400;
	}
}

$img_array = get_post_meta( get_the_ID(), 'st_gallery_post_images', 1 );
if ( ! empty( $img_array ) ) {
	$gallery_images = $img_array;
}

if ( has_post_thumbnail() ) {
	$image_resize = true;

	$image_id  = get_post_thumbnail_id();
	$image_url = wp_get_attachment_url( $image_id );

	$image = st_adamas_aq_resize( $image_url, $width, $height, $image_resize, true, true );
	if ( ! $image ) {
		$image = $image_url;
	}
}

?>

<?php if ( ! empty( $gallery_images ) ) { ?>
    <div class="post-media">
        <div class="post-gallery">
			<?php
			foreach ( $gallery_images as $gallery_image_id => $gallery_image_url ) {
				$image_resize = true;

				$gallery_image_alt = get_post_meta( $gallery_image_id, '_wp_attachment_image_alt', true );

				$gallery_image = st_adamas_aq_resize( $gallery_image_url, $width, $height, $image_resize, true, true );
				if ( ! $gallery_image ) {
					$gallery_image = $gallery_image_url;
				}
				?>
                <img src="<?php echo esc_url( $gallery_image ); ?>" alt="<?php echo esc_attr( $gallery_image_alt ); ?>"/>
			<?php } ?>
        </div>

        <div class="post-gallery-progress">
            <div class="progress"></div>
        </div>
    </div>
<?php } else { ?>
	<?php if ( has_post_thumbnail() ) { ?>
        <div class="post-media">
            <div class="post-thumbnail">
                <img src="<?php echo esc_url( $image ); ?>" alt="<?php the_title_attribute(); ?>"/>
            </div>
        </div>
	<?php }
}