<?php
/**
 * Product loop sale flash
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/loop/sale-flash.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see        https://docs.woocommerce.com/document/template-structure/
 * @author        WooThemes
 * @package    WooCommerce/Templates
 * @version     1.6.4
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $post, $product;

if ( $product->is_on_sale() && $product->is_type( 'simple' ) ) :
	$regular_price = get_post_meta( get_the_ID(), '_regular_price', true );
	$sale_price    = get_post_meta( get_the_ID(), '_sale_price', true );

	$percent      = $sale_price / $regular_price;
	$sale_percent = ( number_format( $percent * 100, 0 ) ) - 100;
	$class        = '';

	if ( get_locale() == 'he_IL' ) {
		$class = 'he-IL';
	}

	echo apply_filters( 'woocommerce_sale_flash', '<span class="onsale ' . $class . '"><span>' . $sale_percent . '</span><span>%</span></span>', $post, $product );

endif;

if ( $product->is_featured() ) :

	echo apply_filters( 'woocommerce_sale_flash', '<span class="featured">' . esc_html__( 'Hot', 'adamas' ) . '</span>', $post, $product );

endif;

/* Omit closing PHP tag at the end of PHP files to avoid "headers already sent" issues. */
