<?php
/**
 * Single Product Share
 *
 * Sharing plugins can hook into here or you can add your own code directly.
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/single-product/share.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you
 * (the theme developer) will need to copy the new files to your theme to
 * maintain compatibility. We try to do this as little as possible, but it does
 * happen. When this occurs the version of the template file will be bumped and
 * the readme will list any important changes.
 *
 * @see     https://docs.woocommerce.com/document/template-structure/
 * @package WooCommerce/Templates
 * @version 3.5.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

do_action( 'woocommerce_share' );

global $st_adamas;

$single_product_sharing = $st_adamas['single_product_sharing']['enabled'];
$shares                 = array();

foreach ( $single_product_sharing as $share_key => $share_value ) {
	if ( $share_key === 'placebo' ) {
		continue;
	}
	$shares[] = $share_key;
}

$shares = array_reverse( $shares );

?>

    <div class="st-single-product-sharing">
        <span><?php esc_html_e( 'Share', 'adamas' ); ?>:</span>
        <div class="st-single-product-sharing-inner" data-shares="<?php echo esc_attr( json_encode( $shares ) ); ?>"></div>
    </div>

<?php
